//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
#include "TDirectDrawForm.h"
//---------------------------------------------------------------------------
#pragma link "TDirectDraw"
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TDirectDrawTestForm *DirectDrawTestForm;
//---------------------------------------------------------------------------
__fastcall TDirectDrawTestForm::TDirectDrawTestForm(TComponent* Owner)
	: TForm(Owner)
{
//for (int i=0;i<ControlCount;i++) { Controls[i]->Visible = false; }
fFrames = 0;
fSeconds = 0;
fColor = 0;
fPaintWithVCL = false;
fPaintWithGDI = false;
fPaintWithDirectDrawDC = false;
fInsidePaintFunction = false;
fDirectDrawingWorked = false;
fPaintingWorked = false;
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::Repaint()
{
if (!fInsidePaintFunction)
	{
	fInsidePaintFunction = true;
	fDirectDrawingWorked = false;
	fPaintingWorked = false;
	if (fPaintWithDirectDrawDC && DirectDraw1->Enabled)
    	{
		DirectDraw1->Log(LOG_IN,"<<FORM>> Repaint()","DirectDraw1 is enabled & will be used for drawing");
        try
            {
            DirectDraw1->Log(LOG_INFO,"<<FORM>>","just about to get DirectDraw DC");
           	HDC hdc = DirectDraw1->GetDC();

            if (hdc)
               	{
	            DirectDraw1->Log(LOG_NOTE,"<<FORM>>","DirectDraw1->GetDC() was successful");
				fDirectDrawingWorked = true;

				HDC original_handle = NULL;
				if (Canvas->Handle != NULL)
					{
				    original_handle = Canvas->Handle;
					DirectDraw1->Log(LOG_INFO,"<<FORM>>","canvas handle is not null, saving handle now");
					}

                try
                	{
		            DirectDraw1->Log(LOG_INFO,"<<FORM>>","just about to set Canvas->DC to the DirectDraw DC");
	 	            Canvas->Handle = hdc;
                    fPaintingWorked = true;
		            DirectDraw1->Log(LOG_INFO,"<<FORM>>","just about to VCL paint to the DirectDraw DC");
	 			    PaintTo(hdc,Left,Top);
	 			    for (int i=0;i<ControlCount;i++) PaintControls(hdc,Controls[i]);
		            DirectDraw1->Log(LOG_INFO,"<<FORM>>","finished VCL paint to the DirectDraw DC");
	 	            Canvas->Handle = NULL;
		            DirectDraw1->Log(LOG_INFO,"<<FORM>>","Canvas->DC has been set to NULL");

                    fPaintingWorked = true;
                    DirectDraw1->Log(LOG_NOTE,"<<FORM>>","VCL painting worked successfully");
                    }
                catch (...)
                	{
                    DirectDraw1->Log(LOG_WARNING,"<<FORM>>","VCL painting caused an exception");
                    fPaintingWorked = false;
                    }

				if (original_handle != NULL)
					{
				    Canvas->Handle = original_handle;
					DirectDraw1->Log(LOG_INFO,"<<FORM>> Constructor","original canvas handle not null, restoring canvas handle");
					}

		        DirectDraw1->Log(LOG_INFO,"<<FORM>>","just about to release the DirectDraw DC");
		        DirectDraw1->ReleaseDC(hdc);
		        DirectDraw1->Log(LOG_NOTE,"<<FORM>>","the DirectDraw supplied DC was released");
				fDirectDrawingWorked = true;
                }
 	        }
        catch (...)
        	{
            fDirectDrawingWorked = false;
            }

        if (fDirectDrawingWorked)
           	{
            DirectDraw1->Log(LOG_NOTE,"<<FORM>>","just about to flip the surface");
            DirectDraw1->Flip();
            DirectDraw1->Log(LOG_NOTE,"<<FORM>>","the surface was flipped");
        	fFlipped = true;
            }
        else
            fFlipped = false;
		DirectDraw1->Log(LOG_OUT,"<<FORM>> Repaint()","finished drawing with directdraw");
        }
	else
	   	{
		fDirectDrawingWorked = false;
		fPaintingWorked = true;
	    fFlipped = false;
	    TForm::Repaint();
        }
	fInsidePaintFunction = false;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::ExitButtonClick(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::PaintWithVCLButtonClick(TObject *Sender)
{
fPaintWithVCL = !fPaintWithVCL;
fPaintWithGDI = false;
fFrames = 0; fSeconds = 0;
//fStartTime = Time();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::PaintWithGDIButtonClick(TObject *Sender)
{
fPaintWithGDI = !fPaintWithGDI;
fPaintWithVCL = false;
fFrames = 0; fSeconds = 0;
//fStartTime = Time();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::PaintWithDirectDrawButtonClick(TObject *Sender)
{
fPaintWithDirectDrawDC = !fPaintWithDirectDrawDC;
DirectDraw1->Enabled = fPaintWithDirectDrawDC;
fFrames = 0; fSeconds = 0;
//fStartTime = Time();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::UpdateDirectXMessages()
{
if (DirectDraw1->ErrorStrings)
	{
	DirectDrawErrorMessagesBox->Items->Clear();
	for (int i=0;i<DirectDraw1->ErrorStrings->Count;i++)
		DirectDrawErrorMessagesBox->Items->Add(DirectDraw1->ErrorStrings->Strings[i]);
	DirectDraw1->ErrorCount = 0;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::FormCreate(TObject *Sender)
{
// debugging clutter
DirectDraw1->Enabled = true;
Width=DirectDraw1->Width; Height=DirectDraw1->Height;
Top=100; Left=0;

PaintWithLabel->Caption = "";
PaintingWorkedLabel->Caption = "";
PaintWithDirectDrawLabel->Caption = "";
DirectDrawingWorkedLabel->Caption = "";
FlippedLabel->Caption = "";

fFrames = 0; fSeconds = 0;
//fStartTime = Time();
}
//---------------------------------------------------------------------------

void __fastcall TDirectDrawTestForm::SecondsTimerTimer(TObject *Sender)
{
fSeconds++;
Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::AnimationTimerTimer(TObject *Sender)
{
fFrames++;
Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TDirectDrawTestForm::FormActivate(TObject *Sender)
{
AnimationTimer->Enabled = true;
if (DirectDraw1->ErrorValue == DD_OK) DirectXInstalledLabel->Caption = "DirectX is Installed";
else DirectXInstalledLabel->Caption = "DirectX is Not Installed";
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::FormDeactivate(TObject *Sender)
{
DirectDrawErrorMessagesBox->Items->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::BitBtn1Click(TObject *Sender)
{
UpdateDirectXMessages();
DirectDrawErrorMessagesBox->Refresh();
Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::FormPaint(TObject *Sender)
{
//int 		seconds_elapsed = Time() - fStartTime;
int seconds_elapsed = fSeconds;

// BEGIN REGULAR DRAW CODE
fColor++;
FramesLabel->Caption = "Frames: " + IntToStr(fFrames);
SecondsLabel->Caption = "Seconds: " + IntToStr(seconds_elapsed);
if (seconds_elapsed != 0) FramesPerSecondLabel->Caption = "FPS: " + FloatToStrF((float)fFrames / (float)seconds_elapsed, ffFixed, 6, 2);

if (DirectDraw1->Debugging) DebuggingLabel->Caption = "DirectX debugging is ON";
else DebuggingLabel->Caption = "DirectX debugging is OFF";

if (fPaintWithVCL)
	{
	if (fPaintWithDirectDrawDC)
    	{
		PaintWithVCLButton->Caption = "Painting with &VCL on DIRECTX surface: ON";
        PaintWithLabel->Caption = "Using standard VCL functions to paint on a DirectX surface";
		PaintWithLabel->Font->Color = clGreen;
        }
    else
    	{
        PaintWithVCLButton->Caption = "Paint with &VCL on VCL canvas: ON";
        PaintWithLabel->Caption = "Using standard VCL functions to paint on a VCL canvas";
		PaintWithLabel->Font->Color = clRed;
        }
    PaintWithVCL();
    }
else
	{
    if (fPaintWithDirectDrawDC)	PaintWithVCLButton->Caption = "Paint with &VCL on DIRECTX surface: OFF";
	else PaintWithVCLButton->Caption = "Paint with &VCL on VCL canvas: OFF";
    }
if (fPaintWithGDI)
	{
	if (fPaintWithDirectDrawDC)
    	{
        PaintWithGDIButton->Caption = "Paint with &GDI on DIRECTX surface: ON";
        PaintWithLabel->Caption = "Using standard GDI functions to paint on a DirectX surface";
		PaintWithLabel->Font->Color = clGreen;
        }
    else
    	{
        PaintWithGDIButton->Caption = "Paint with &GDI on VCL canvas: ON";
        PaintWithLabel->Caption = "Using standard GDI functions to paint on a VCL canvas";
		PaintWithLabel->Font->Color = clRed;
        }
    PaintWithGDI();
    }
else
	{
	if (fPaintWithDirectDrawDC) PaintWithGDIButton->Caption = "Paint with &GDI on DIRECTX surface: OFF";
    else PaintWithGDIButton->Caption = "Paint with &GDI on VCL canvas: OFF";
    }

if (fPaintWithDirectDrawDC)
	{
    PaintWithDirectDrawButton->Caption = "Paint directly on &DirectX surface: ON";
    PaintWithDirectDrawLabel->Caption = "Attempting to paint directly on DirectX surface";
	PaintWithDirectDrawLabel->Font->Color = clGreen;
    }
else
	{
    PaintWithDirectDrawButton->Caption = "Paint directly on &DirectX surface: OFF";
    PaintWithDirectDrawLabel->Caption = "Not attempting to paint directly on DirectX surface";
	PaintWithDirectDrawLabel->Font->Color = clRed;
    }
if (fFlipped)
	{
    FlippedLabel->Caption = "DirectDraw surface was flipped";
    FlippedLabel->Font->Color = clGreen;
    }
else
	{
    FlippedLabel->Caption = "DirectDraw surface was not flipped";
    FlippedLabel->Font->Color = clRed;
    }
if (fDirectDrawingWorked)
	{
    DirectDrawingWorkedLabel->Caption = "DirectDraw GetDC/ReleaseDC worked successfully";
    DirectDrawingWorkedLabel->Font->Color = clGreen;
    }
else
	{
    DirectDrawingWorkedLabel->Caption = "DirectDraw GetDC/ReleaseDC did not work successfully";
    DirectDrawingWorkedLabel->Font->Color = clRed;
    }
if (fPaintingWorked)
	{
	if (fPaintWithVCL) PaintingWorkedLabel->Caption = "VCL Paint functions worked successfully";
	if (fPaintWithGDI) PaintingWorkedLabel->Caption = "GDI Paint functions worked successfully";
    PaintingWorkedLabel->Font->Color = clGreen;
    }
else
	{
    if (fPaintWithVCL) PaintingWorkedLabel->Caption = "VCL Paint functions did not work successfully";
    if (fPaintWithGDI) PaintingWorkedLabel->Caption = "GDI Paint functions did not work successfully";
    PaintingWorkedLabel->Font->Color = clRed;
    }
}
//---------------------------------------------------------------------------
int x = 0;
int y = 0;
int xincr = 1;
int yincr = 1;
//---------------------------------------------------------------------------
void	__fastcall	TDirectDrawTestForm::PaintWithVCL()
{
if (Canvas->Handle)
	{
	// use the standard VCL functions to draw on the DirectX surface as we see fit
    x += xincr;
    y += yincr;

    if (x<0) xincr = 1;
    if (y<0) yincr = 1;
    if (x+400>Width) xincr = -1;
    if (y+200>Height) yincr = -1;

    Canvas->Pen->Color = (TColor) RGB(255,255,255);
	Canvas->Brush->Color = (TColor) RGB((x*128)%256,(x*16)%256,(x*16+16*fColor)%256) ;
    Canvas->Brush->Style = bsSolid;
	Canvas->Rectangle( x,y, x+400,y+200 );

    /*	for (int x=0;x<Width / 128;x++)
		for (int y=0;y<Height / 16;y++)
	       	{
		    Canvas->Pen->Color = (TColor) RGB(255,255,255);
		    Canvas->Brush->Color = (TColor) RGB((x*128+y*16)%256,(x*16+y*128)%256,(x*16+y*16+16*fColor)%256) ;
	        Canvas->TextOut( x * 128 + fFrames % 128, y * 16, "THIS IS A TEST" );
	        } */
	}
}
//---------------------------------------------------------------------------
void	__fastcall	TDirectDrawTestForm::PaintWithGDI()
{
if (Canvas->Handle)
	{
	// use standard GDI functions to manipulate the DirectX surface as we see fit
    x += xincr;
    y += yincr;

    if (x<0) xincr = 1;
    if (y<0) yincr = 1;
    if (x+400>Width) xincr = -1;
    if (y+200>Height) yincr = -1;

    SetTextColor( Canvas->Handle, RGB(255,255,255));
	SetBkColor( Canvas->Handle, RGB((x*128)%256,(x*16)%256,(x*16+16*fColor)%256));
    RECT r;
    r.left = x;
    r.top = y;
    r.right = x+400;
    r.bottom = y+200;
    FillRect( Canvas->Handle, &r, 0 );

/*	for (int x=0;x<DirectDraw1->Width / 128;x++)
		for (int y=0;y<DirectDraw1->Height / 16;y++)
	    	{
		    SetTextColor( DirectDraw1->Handle, RGB(255,255,255) );
		    SetBkColor( DirectDraw1->Handle, RGB((x*128+y*16)%256,(x*16+y*128)%256,(x*16+y*16+16*fColor)%256) );
	        TextOut( DirectDraw1->Handle, x * 128 + fFrames % 128, y * 16, "THIS IS A TEST", strlen("THIS IS A TEST") );
	        } */
    }
}
//---------------------------------------------------------------------------

void __fastcall TDirectDrawTestForm::BitBtn3Click(TObject *Sender)
{
DirectDraw1->Debugging = !DirectDraw1->Debugging;
Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::BitBtn2Click(TObject *Sender)
{
DirectDraw1->ErrorStrings->Clear();
Refresh();
}
//---------------------------------------------------------------------------
