//---------------------------------------------------------------------------
#ifndef TDirectDrawFormH
#define TDirectDrawFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
#include "TDirectDraw.h"
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------
class TDirectDrawTestForm : public TForm
{
__published:	// IDE-managed Components
	TPanel *TimingPanel;
	TLabel *FramesLabel;
	TLabel *SecondsLabel;
	TLabel *FramesPerSecondLabel;
	TTimer *SecondsTimer;
	TPanel *InformationPanel;
	TListBox *DirectDrawErrorMessagesBox;
	TBitBtn *ExitButton;
	TButton *PaintWithGDIButton;
	TButton *PaintWithVCLButton;
	TButton *PaintWithDirectDrawButton;
	TLabel *PaintWithLabel;
	TTimer *AnimationTimer;
	TDirectDraw *DirectDraw1;
	TLabel *DirectXInstalledLabel;
	TLabel *FlippedLabel;
	TLabel *PaintWithDirectDrawLabel;
	TLabel *PaintingWorkedLabel;
	TShape *Shape1;
	TLabel *DirectDrawingWorkedLabel;
	TLabel *DebuggingLabel;
	TBitBtn *BitBtn1;
	TBitBtn *BitBtn2;
	TBitBtn *BitBtn3;
	void __fastcall ExitButtonClick(TObject *Sender);
	void __fastcall PaintWithGDIButtonClick(TObject *Sender);
	void __fastcall PaintWithVCLButtonClick(TObject *Sender);
	void __fastcall PaintWithDirectDrawButtonClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall SecondsTimerTimer(TObject *Sender);
	void __fastcall AnimationTimerTimer(TObject *Sender);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall FormDeactivate(TObject *Sender);
	void __fastcall BitBtn1Click(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);
	
	
	
	void __fastcall BitBtn3Click(TObject *Sender);
	void __fastcall BitBtn2Click(TObject *Sender);
private:	// User declarations
	unsigned int		fFrames;
    unsigned int		fSeconds;
    unsigned int		fColor;
    bool				fFlipped;
    bool				fDrawingOnDirectXSurface;
    bool				fDirectDrawingWorked;
    bool				fPaintingWorked;
    bool				fInsidePaintFunction;
	TDateTime			fStartTime;
protected:
    bool				fPaintWithVCL;
    bool				fPaintWithGDI;
    bool				fPaintWithDirectDrawDC;

//	void		__fastcall	PaintWindow(HDC hdc);
//	void 		__fastcall	PaintControls(HDC DC, TControl* First);
	void 		__fastcall 	Repaint();

	void		__fastcall	PaintWithVCL();
	void		__fastcall	PaintWithGDI();
    
public:		// User declarations
	__fastcall TDirectDrawTestForm(TComponent* Owner);
    void		__fastcall	UpdateDirectXMessages();
};
//---------------------------------------------------------------------------
extern TDirectDrawTestForm *DirectDrawTestForm;
//---------------------------------------------------------------------------
#endif
/*

procedure TForm. ClientWndProc(var Message: TMessage);

  procedure Default;
  begin
    with Message do
      Result := CallWindowProc(FDefClientProc, ClientHandle, Msg, wParam, lParam);
  end;

begin
  with Message do
    case Msg of
      WM_NCHITTEST:
        begin
          Default;
          if Result = HTCLIENT then Result := HTTRANSPARENT;
        end;
      WM_ERASEBKGND:
        begin
          FillRect(TWMEraseBkGnd(Message).DC, ClientRect, Brush.Handle);
          Result := 1;
        end;
    else
      Default;
    end;
end;

*/

