//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
#include "TDirectDrawForm.h"
//---------------------------------------------------------------------------
#pragma link "TDirectDraw"
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TDirectDrawTestForm *DirectDrawTestForm;
//---------------------------------------------------------------------------
__fastcall TDirectDrawTestForm::TDirectDrawTestForm(TComponent* Owner)
	: TForm(Owner)
{
fAnimationTicks = 0;
fFramesFlipped = 0;
fSeconds = 0;
fColor = 0;

fPaintWithVCL = false;
fPaintWithGDI = false;
fPaintWithDirectDrawDC = false;
fInsidePaintFunction = false;

fDrawingOnDirectXDC = false;
fDrawingOnDirectXDCWorked = false;
fSaveCanvasHandle = false;
fSaveCanvasHandleWorked = false;
fRestoreCanvasHandle = false;
fRestoreCanvasHandleWorked = false;
fDrawingVCLOnDirectX = false;
fDrawingVCLOnDirectXWorked = false;
fSurfaceWasFlipped = false;

fDirectDraw = new TDirectDraw(this);
if (fDirectDraw != NULL) DirectDraw->Debugging = true;
}
//---------------------------------------------------------------------------
__fastcall 	TDirectDrawTestForm::~TDirectDrawTestForm()
{
delete fDirectDraw;
}
//---------------------------------------------------------------------------
/*void __fastcall	TDirectDrawTestForm::PaintTo(HDC hdc, int X, int Y)
{
DirectDraw->Log(LOG_IN,"<<FORM>> PaintTo()","");
if (hdc == NULL)
	{
	DirectDraw->Log(LOG_OUT,"<<FORM>> PaintTo()","hdc is NULL");
    return;
    }

int EdgeFlags;
int BorderFlags;
RECT R;
TPoint origin;

// save the current DC origin
GetWindowOrgEx(hdc, &origin);

// set the DC origin to the top-left draw coords
MoveWindowOrg(hdc, X, Y);

// make sure windows knows the correct region to clip
IntersectClipRect(hdc, 0, 0, Width, Height);

// figure out the border style bits & pieces
BorderFlags = 0;
EdgeFlags = 0;
if ((GetWindowLong(Handle, GWL_EXSTYLE) & WS_EX_CLIENTEDGE) != 0)
	{
	EdgeFlags = EDGE_SUNKEN;
    BorderFlags = BF_RECT | BF_ADJUST;
    }
else
	if ((GetWindowLong(Handle, GWL_STYLE) & WS_BORDER) != 0)
		{
        EdgeFlags = BDR_OUTER;
	    BorderFlags = BF_RECT | BF_ADJUST | BF_MONO;
		}

// draw a border iff required
if (BorderFlags != 0)
	{
    SetRect(&R, 0, 0, Width, Height);
    DrawEdge(hdc, &R, EdgeFlags, BorderFlags);
    MoveWindowOrg(hdc, R.left, R.top);
    IntersectClipRect(hdc, 0, 0, R.right - R.left, R.bottom - R.top);
    }

// modify default behaviour of the form
ControlState << csPaintCopy;

// paint the form
Perform(WM_PAINT, (long) hdc, NULL);

// restore the original state of the form & DC
ControlState >> csPaintCopy;

// restore the original window origin
SetWindowOrgEx(hdc, origin.x, origin.y, NULL);
DirectDraw->Log(LOG_OUT,"<<FORM>> PaintTo()","");
} */
//---------------------------------------------------------------------------
void	__fastcall	TDirectDrawTestForm::PaintControls(HDC hdc, TControl* First)
{
DirectDraw->Log(LOG_IN,"<<FORM>> PaintControls()","");
if (ControlCount == 0)
	{
	DirectDraw->Log(LOG_OUT,"<<FORM>> PaintControls()","ControlCount is 0");
    return;
    }

int i = 0;
if (hdc != NULL)
	{
	int j=0;
    while (j<ControlCount)
    	{
		if (Controls[j] == First) i = j;
        j++;
        }
    }
int k = 0;
while (k<ControlCount)
	{
//    RECT r;
//    r.left = Controls[i]->Left;
//    r.top  = Controls[i]->Top;
//    r.right  = Controls[i]->Left + Controls[i]->Width;
//    r.bottom = Controls[i]->Top + Controls[i]->Height;

   	if (Controls[i]->Visible) //&& (RectVisible(hdc, &r)))
    	{
		DirectDraw->Log(LOG_OUT,"<<FORM>> PaintControls()","Painting Control - '" + Controls[i]->Name + "'");
     	TWinControl* control = (TWinControl*) Controls[i];

        MoveWindowOrg(hdc, control->Left, control->Top);
        IntersectClipRect(hdc, 0, 0, control->Width, control->Height);

        bool paintcopy;
		if (ControlState.Contains(csPaintCopy))
        	{
	        control->ControlState << csPaintCopy;
            paintcopy = true;
            }
        else
        	paintcopy = false;
//        control->Perform(WM_ERASEBKGND, (long) hdc, NULL);
        control->Perform(WM_PAINT, (long) hdc, NULL);
		if (paintcopy) control->ControlState >> csPaintCopy;

        MoveWindowOrg(hdc, -control->Left, -control->Top);
        }

    ++i %= ControlCount;	// wrap to 0..ControlCount-1
    k++;
    }
DirectDraw->Log(LOG_OUT,"<<FORM>> PaintControls()","painted " + IntToStr(k) + " controls");
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::PaintHandler(Messages::TWMPaint &Message)
{
if (!fInsidePaintFunction)
	{
	fInsidePaintFunction = true;

	if (fPaintWithDirectDrawDC && DirectDraw->Enabled)
    	{
		DirectDraw->Log(LOG_IN,"<<FORM>> PaintHandler()","DirectDraw is enabled & will be used for drawing");
        DirectDraw->Log(LOG_INFO,"<<FORM>> PaintHandler()","just about to get DirectDraw DC");
        // this returns the backbuffer if possible, primary surface otherwise
      	HDC hdc = DirectDraw->GetDC();

        if (hdc != NULL)
           	{
            DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","DirectDraw->GetDC() was successful");
            fDrawingOnDirectXDC = true;

            // deallocate anything to do with the Canvas and set it to use the DirectX supplied DC
	        fSaveCanvasHandle = true;
            fSaveCanvasHandleWorked = false;
	        DirectDraw->Log(LOG_INFO,"<<FORM>> PaintHandler()","about to setup Canvas->Handle");
	        try
            	{
		        if (Canvas->Handle)
	               	{
//		            DirectDraw->Log(LOG_INFO,"<<FORM>> PaintHandler()","Canvas->Handle is not null, about to be freed");
//	 	            ((TControlCanvas*) Canvas)->FreeHandle();

	 		        DirectDraw->Log(LOG_INFO,"<<FORM>> PaintHandler()","Canvas->Handle about to be set to directdraw dc");
	 	            ((TControlCanvas*) Canvas)->Handle = hdc;

			        fSaveCanvasHandle = true;
                    fSaveCanvasHandleWorked = true;
	 		        DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","Canvas->Handle has been set to directdraw dc");
                	}
		        else
	               	{
	                fSaveCanvasHandle = false;
                    fSaveCanvasHandleWorked = false;
		            DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","Canvas->Handle is not allocated");
	                }
                }
            catch (...)
            	{
                fSaveCanvasHandle = false;
                fSaveCanvasHandleWorked = false;
	            DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","Canvas->Handle caused an exception");
                }

            // paint using standard VCL functions directly on the DirectX supplied surface
            fDrawingVCLOnDirectX = true;
	        fDrawingVCLOnDirectXWorked = false;
	        DirectDraw->Log(LOG_INFO,"<<FORM>> PaintHandler()","about to attempt VCL paint to the DirectDraw DC");
            try
            	{
	            if (ControlCount==0)
                	{
			        DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","about to PaintWindow only because there are no controls");
                    PaintWindow(hdc);
                    }
	            else
	               	{
			        DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","setting control clip regions");
//					int Clip = SIMPLEREGION;
//					for (int i=0;i<ControlCount;i++)
//						if (Controls[i]->Visible)
//					    	{
//					        DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","excluding control '" + Controls[i]->Name + "'");
//					        Clip = ExcludeClipRect(hdc,Controls[i]->Left,Controls[i]->Top,Controls[i]->Left+Controls[i]->Width,Controls[i]->Top+Controls[i]->Height);
//							if (Clip == NULLREGION) break;
//					        }
//					if (Clip != NULLREGION)
//                    	{
//				        DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","ClipRegion not null, about to PaintWindow()");
                        PaintWindow(hdc);
//                        }
	                }
		        DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","about to PaintControls()");
	            PaintControls(hdc,NULL);

	            fDrawingVCLOnDirectX = true;
		        fDrawingOnDirectXDCWorked = true;
		        DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","VCL painting on DirectDraw DC was successful");
                }
            catch (...)
              	{
	            fDrawingVCLOnDirectX = true;
	            fDrawingOnDirectXDCWorked = false;
	            DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","VCL painting on DirectDraw DC NOT successful");
                }

            // reset the Canvas to NOT use the DirectX supplied DC
            fRestoreCanvasHandle = true;
            fRestoreCanvasHandleWorked = false;
	        DirectDraw->Log(LOG_INFO,"<<FORM>> PaintHandler()","about to restore Canvas->Handle");
			try
            	{
                if (fSaveCanvasHandle)
               		{
		            DirectDraw->Log(LOG_INFO,"<<FORM>> PaintHandler()","about to set the Canvas->Handle to NULL");
                    ((TControlCanvas*) Canvas)->Handle = NULL;

		            fRestoreCanvasHandle = true;
	                fRestoreCanvasHandleWorked = true;
			        DirectDraw->Log(LOG_INFO,"<<FORM>> PaintHandler()","Canvas->Handle has been restored");
	                }
		        else
	            	{
	                fRestoreCanvasHandle = false;
	                fRestoreCanvasHandleWorked = false;
	                DirectDraw->Log(LOG_ERROR,"<<FORM>> PaintHandler()","Canvas->Handle was not saved, not restored");
    	            }
                }
            catch (...)
            	{
                fRestoreCanvasHandle = false;
                fRestoreCanvasHandleWorked = false;
                DirectDraw->Log(LOG_ERROR,"<<FORM>> PaintHandler()","restore Canvas->Handle caused an exception");
                }

	       	DirectDraw->Log(LOG_INFO,"<<FORM>> PaintHandler()","just about to release the DirectDraw DC");
	       	DirectDraw->ReleaseDC(hdc);

            for (int adelay=0;adelay<1000000;adelay++) ;
            
	        DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","just about to flip the surface");
	        fSurfaceWasFlipped = DirectDraw->Flip();
            
	      	DirectDraw->Log(LOG_NOTE,"<<FORM>> PaintHandler()","!! Direct Drawing Worked !!");
            }
        else	// if (hdc == NULL)
        	{
            fDrawingOnDirectXDC = false;
 			fDrawingOnDirectXDCWorked = false;
            fSurfaceWasFlipped = false;
	       	DirectDraw->Log(LOG_ERROR,"<<FORM>> PaintHandler()","DC returned from DirectDraw is NULL");
            }

 		DirectDraw->Log(LOG_OUT,"<<FORM>> PaintHandler()","finished drawing with directdraw");
        }
	else
	   	{
		fDrawingOnDirectXDC = false;
		fDrawingOnDirectXDCWorked = false;
		fSaveCanvasHandle = false;
		fSaveCanvasHandleWorked = false;
		fRestoreCanvasHandle = false;
		fRestoreCanvasHandleWorked = false;
		fDrawingVCLOnDirectX = false;
		fDrawingVCLOnDirectXWorked = false;
		fSurfaceWasFlipped = false;
	    TForm::PaintHandler(Message);
        }
	fInsidePaintFunction = false;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::ExitButtonClick(TObject *Sender)
{
if (Enabled) Close();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::PaintWithVCLButtonClick(TObject *Sender)
{
fPaintWithVCL = !fPaintWithVCL;
fPaintWithGDI = false;
fFramesFlipped = 0; fSeconds = 0; fAnimationTicks = 0;
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::PaintWithGDIButtonClick(TObject *Sender)
{
fPaintWithGDI = !fPaintWithGDI;
fPaintWithVCL = false;
fFramesFlipped = 0; fSeconds = 0; fAnimationTicks = 0;
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::PaintWithDirectDrawButtonClick(TObject *Sender)
{
fPaintWithDirectDrawDC = !fPaintWithDirectDrawDC;
DirectDraw->Enabled = fPaintWithDirectDrawDC;
fFramesFlipped = 0; fSeconds = 0; fAnimationTicks = 0;
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::UpdateDirectXMessages()
{
if (DirectDraw->ErrorStrings)
	{
	DirectDrawErrorMessagesBox->Items->Clear();
	for (int i=0;i<DirectDraw->ErrorStrings->Count;i++)
		DirectDrawErrorMessagesBox->Items->Add(DirectDraw->ErrorStrings->Strings[i]);
	DirectDraw->ErrorCount = 0;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::FormCreate(TObject *Sender)
{
bool all_enabled = true;
DirectDraw->Enabled = true;
if (DirectDraw->Enabled)	
	{
	if (DirectDraw->SetDisplayMode(640,480,8))
    	{
	    AnimationTimer->Interval = AutoFlipTimer->Interval;
	    AnimationTimer->Enabled = true;
	    AutoFlipTimer->Enabled = true;
        all_enabled = true;
        }
    }
//else
//	ShowMessage("DirectDraw could not be enabled");

if (!all_enabled)
	{
    for (int i=0;i<ControlCount;i++) Controls[i]->Enabled = false;
    AnimationTimer->Enabled = false;
    AutoFlipTimer->Enabled = false;
    }

Left=0; Width=DirectDraw->Width-Left;
Top=5; Height=DirectDraw->Height-Top;
DirectDrawErrorMessagesBox->Height -= 5;

fFramesFlipped = 0; fSeconds = 0; fAnimationTicks = 0;
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::FormActivate(TObject *Sender)
{
AnimationTimer->Enabled = true;
if (DirectDraw->ErrorValue == DD_OK) DirectXInstalledLabel->Caption = "DirectX is Installed";
else DirectXInstalledLabel->Caption = "DirectX is Not Installed";
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::FormDeactivate(TObject *Sender)
{
AnimationTimer->Enabled = false;
AutoFlipTimer->Enabled = false;
DirectDraw->Enabled = false;
DirectDrawErrorMessagesBox->Items->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::FormPaint(TObject *Sender)
{
int seconds_elapsed = fSeconds;

// BEGIN REGULAR DRAW CODE
TicksLabel->Caption = "Ticks: " + IntToStr(fAnimationTicks);
FramesLabel->Caption = "Frames: " + IntToStr(fFramesFlipped);
SecondsLabel->Caption = "Seconds: " + IntToStr(seconds_elapsed);
if (seconds_elapsed != 0)
	{
    FramesPerSecondLabel->Caption = "FPS: " + FloatToStrF((float)fFramesFlipped / (float)seconds_elapsed, ffFixed, 6, 2);
	TicksPerSecondLabel->Caption = "TPS: " + FloatToStrF((float)fAnimationTicks / (float)seconds_elapsed, ffFixed, 6, 2);
	}

if (fPaintWithVCL)
	{
	if (fPaintWithDirectDrawDC)
    	{
		PaintWithVCLButton->Caption = "Painting with &VCL on DIRECTX surface: ON";
        PaintWithLabel->Caption = "Using standard VCL functions to paint on a DirectX surface";
		PaintWithLabel->Font->Color = clGreen;
        }
    else
    	{
        PaintWithVCLButton->Caption = "Paint with &VCL on VCL canvas: ON";
        PaintWithLabel->Caption = "Using standard VCL functions to paint on a VCL canvas";
		PaintWithLabel->Font->Color = clRed;
        }
    PaintWithVCL();
    }
else
	{
    if (fPaintWithDirectDrawDC)	PaintWithVCLButton->Caption = "Paint with &VCL on DIRECTX surface: OFF";
	else PaintWithVCLButton->Caption = "Paint with &VCL on VCL canvas: OFF";
    }
if (fPaintWithGDI)
	{
	if (fPaintWithDirectDrawDC)
    	{
        PaintWithGDIButton->Caption = "Paint with &GDI on DIRECTX surface: ON";
        PaintWithLabel->Caption = "Using standard GDI functions to paint on a DirectX surface";
		PaintWithLabel->Font->Color = clGreen;
        }
    else
    	{
        PaintWithGDIButton->Caption = "Paint with &GDI on VCL canvas: ON";
        PaintWithLabel->Caption = "Using standard GDI functions to paint on a VCL canvas";
		PaintWithLabel->Font->Color = clRed;
        }
    PaintWithGDI();
    }
else
	{
	if (fPaintWithDirectDrawDC) PaintWithGDIButton->Caption = "Paint with &GDI on DIRECTX surface: OFF";
    else PaintWithGDIButton->Caption = "Paint with &GDI on VCL canvas: OFF";
    }
if (fPaintWithDirectDrawDC)PaintWithDirectDrawButton->Caption = "Paint directly on &DirectX surface: ON";
else PaintWithDirectDrawButton->Caption = "Paint directly on &DirectX surface: OFF";

if (DirectDraw->Debugging)
	{
    DebuggingLabel->Font->Color = clGreen;
    DebuggingLabel->Caption = "DirectX debugging is ON";
    }
else
	{
    DebuggingLabel->Font->Color = clRed;
    DebuggingLabel->Caption = "DirectX debugging is OFF";
    }

if (fDrawingOnDirectXDC)
	{
    DrawingOnDirectXDCLabel->Font->Color = clGreen;
    DrawingOnDirectXDCLabel->Caption = "drawing on DirectX supplied surface";
    }
else
	{
    DrawingOnDirectXDCLabel->Font->Color = clRed;
    DrawingOnDirectXDCLabel->Caption = "drawing on VCL supplied surface";
    }

if (fDrawingOnDirectXDCWorked)
	{
    DrawingOnDirectXDCWorkedLabel->Font->Color = clGreen;
    DrawingOnDirectXDCWorkedLabel->Caption = "drawing on DirectX surface worked";
    }
else
	{
    DrawingOnDirectXDCWorkedLabel->Font->Color = clRed;
    DrawingOnDirectXDCWorkedLabel->Caption = "drawing on DirectX surface failed";
    }

if (fSaveCanvasHandle)
	{
    SaveCanvasHandleLabel->Font->Color = clGreen;
    SaveCanvasHandleLabel->Caption = "canvas handle was saved (freed)";
    }
else
	{
    SaveCanvasHandleLabel->Font->Color = clRed;
    SaveCanvasHandleLabel->Caption = "canvas handle was not saved (freed)";
    }

if (fSaveCanvasHandleWorked)
	{
    SaveCanvasHandleWorkedLabel->Font->Color = clGreen;
    SaveCanvasHandleWorkedLabel->Caption = "canvas handle was saved (freed) correctly";
    }
else
	{
    SaveCanvasHandleWorkedLabel->Font->Color = clRed;
    SaveCanvasHandleWorkedLabel->Caption = "canvas handle did not save (free) correctly";
    }

if (fRestoreCanvasHandle)
	{
    RestoreCanvasHandleLabel->Font->Color = clGreen;
    RestoreCanvasHandleLabel->Caption = "canvas handle was restored";
    }
else
	{
    RestoreCanvasHandleLabel->Font->Color = clRed;
    RestoreCanvasHandleLabel->Caption = "canvas handle was not not restored";
    }

if (fRestoreCanvasHandleWorked)
	{
    RestoreCanvasHandleWorkedLabel->Font->Color = clGreen;
    RestoreCanvasHandleWorkedLabel->Caption = "canvas handle was restored (zeroed) correctly";
    }
else
	{
    RestoreCanvasHandleWorkedLabel->Font->Color = clRed;
    RestoreCanvasHandleWorkedLabel->Caption = "canvas handle did not restore (zero) correctly";
    }

if (fDrawingVCLOnDirectX)
	{
    DrawingVCLOnDirectXLabel->Caption = "attempting to use VCL to draw on DirectX DC";
    }
else
	{
    DrawingVCLOnDirectXLabel->Caption = "not using VCL to draw on DirectX DC ?? reason?";
    }

if (fDrawingVCLOnDirectXWorked)
	{
    DrawingVCLOnDirectXWorkedLabel->Caption = "Drawing using VCL on DirectX surface worked";
    }
else
	{
    DrawingVCLOnDirectXWorkedLabel->Caption = "Drawing using VCL on DirectX not working";
    }

if (fSurfaceWasFlipped)
	{
    
    SurfaceWasFlippedLabel->Caption = "surface was flipped";
    }
else
	{
    SurfaceWasFlippedLabel->Caption = "surface was not flipped";
    }
}
//---------------------------------------------------------------------------
int x = 0;
int y = 0;
int xincr = 1;
int yincr = 1;
//---------------------------------------------------------------------------
void	__fastcall	TDirectDrawTestForm::PaintWithVCL()
{
// use the standard VCL functions to draw on the DirectX surface as we see fit
Canvas->Pen->Color = (TColor) RGB(255,255,255);
Canvas->Brush->Color = (TColor) RGB((x*128)%256,(x*16)%256,(x*16+16*fColor)%256) ;
Canvas->Brush->Style = bsSolid;
Canvas->Rectangle( x,y, x+400,y+200 );
}
//---------------------------------------------------------------------------
void	__fastcall	TDirectDrawTestForm::PaintWithGDI()
{
// use standard GDI functions to manipulate the DirectX surface as we see fit
SetTextColor( Canvas->Handle, RGB(255,255,255));
SetBkColor( Canvas->Handle, RGB((x*128)%256,(x*16)%256,(x*16+16*fColor)%256));
RECT r;
r.left = x;
r.top = y;
r.right = x+400;
r.bottom = y+200;
FillRect( Canvas->Handle, &r, 0 );
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::BitBtn1Click(TObject *Sender)
{
if (Enabled)
	{
	UpdateDirectXMessages();
	DirectDrawErrorMessagesBox->Refresh();
	Refresh();
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::BitBtn2Click(TObject *Sender)
{
if (Enabled)
	{
    DirectDraw->ErrorStrings->Clear();
	Refresh();
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::BitBtn3Click(TObject *Sender)
{
if (Enabled)
	{
    DirectDraw->Debugging = !DirectDraw->Debugging;
	Refresh();
    }
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::SecondsTimerTimer(TObject *Sender)
{
fSeconds++;
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::AnimationTimerTimer(TObject *Sender)
{
fAnimationTicks++;

// animation code
fColor++;
x += xincr;
y += yincr;

if (x<0) xincr = 1;
if (y<0) yincr = 1;
if (x+400>Width) xincr = -1;
if (y+200>Height) yincr = -1;
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::AutoFlipTimerTimer(TObject *Sender)
{
fFramesFlipped++;
Refresh();
}
//---------------------------------------------------------------------------
// remember: function SetPriorityClass(hProcess: THandle; dwPriorityClass: DWORD): BOOL; stdcall;

void __fastcall TDirectDrawTestForm::BitBtn4Click(TObject *Sender)
{
if (Enabled) if (AnimationTimer->Interval>20) AnimationTimer->Interval -= 20;
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::BitBtn5Click(TObject *Sender)
{
if (Enabled) if (AnimationTimer->Interval<2000) AnimationTimer->Interval += 20;
}
//---------------------------------------------------------------------------
void __fastcall TDirectDrawTestForm::FormDestroy(TObject *Sender)
{
DirectDrawErrorMessagesBox->Items->Clear();
}
//---------------------------------------------------------------------------
