//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
#include "TDDForm.h"
#include "winresrc.h"
#include "penwin.h"
//---------------------------------------------------------------------------
#pragma link "TDirectDraw"
#pragma link "Grids"
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TDDForm *DDForm;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// remember: 	SetPriorityClass(hProcess: THandle; dwPriorityClass: DWORD): BOOL; stdcall;
// remember:	Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
void __fastcall	MyFrame3DWindow( TCanvas* canvas, int left,int top,int right,int bottom,int penwidth )
{
if (canvas == NULL) return;

// color entire frame with single color
canvas->Pen->Style = psSolid;
canvas->Pen->Width = 1;
canvas->Pen->Color = clBtnFace;
canvas->Brush->Style = bsClear;
for (int i=0;i<penwidth;i++) canvas->Rectangle(left+i, top+i, right-i, bottom-i );

// darken left edge
canvas->Pen->Color = clBtnShadow;
canvas->MoveTo( left, top );
canvas->LineTo( left, bottom );
// darken top edge
canvas->MoveTo( left, top );
canvas->LineTo( right-1, top );

// lighten left edge
canvas->Pen->Color = clBtnHighlight;
canvas->MoveTo( left+1, top+1 );
canvas->LineTo( left+1, bottom-1 );

// lighten top edge
canvas->MoveTo( left+1, top+1 );
canvas->LineTo( right-2, top+1 );

// darken right edge
canvas->Pen->Color = cl3DDkShadow;
canvas->MoveTo( right, top );
canvas->LineTo( right, bottom );
canvas->Pen->Color = clBtnShadow;
canvas->MoveTo( right-1, top+1 );
canvas->LineTo( right-1, bottom-1 );
// darken bottom edge
canvas->Pen->Color = cl3DDkShadow;
canvas->MoveTo( left, bottom );
canvas->LineTo( right, bottom );
canvas->Pen->Color = clBtnShadow;
canvas->MoveTo( left+1, bottom-1 );
canvas->LineTo( right-1, bottom-1 );
}
//---------------------------------------------------------------------------
void __fastcall	MyFrame3DButton( TCanvas* canvas, int left,int top,int right,int bottom)
{
if (canvas == NULL) return;

canvas->Pen->Style = psSolid;
canvas->Pen->Width = 1;

// start at bottom,left corner
canvas->MoveTo(left,bottom);
// draw left edge
canvas->Pen->Color = clBtnHighlight;
canvas->LineTo(left,top);
// draw top edge
canvas->LineTo(right,top);
// draw right edge
canvas->Pen->Color = cl3DDkShadow;
canvas->LineTo(right,bottom);
// draw bottom edge
canvas->LineTo(left-1,bottom);
// extra highlight
left++;
right--;
top++;
bottom--;
// draw right edge
canvas->Pen->Color = clBtnShadow;
canvas->MoveTo(right,top);
canvas->LineTo(right,bottom);
// draw bottom edge
canvas->LineTo(left-1,bottom);
}
//---------------------------------------------------------------------------
void __fastcall MyFrame3DThumbnail( TCanvas* canvas, int left, int top, int right, int bottom)
{
if (canvas == NULL) return;

canvas->Pen->Style = psSolid;
canvas->Pen->Width = 1;

// fill rect
canvas->Pen->Style = psClear;
canvas->Brush->Style = bsSolid;
canvas->Brush->Color = clBtnFace;
canvas->Rectangle( left, top, right, bottom );

// start at bottom,left corner
canvas->Pen->Style = psSolid;
canvas->MoveTo(left,bottom);
// draw left edge
canvas->Pen->Color = clBtnFace;
canvas->LineTo(left,top);
// draw top edge
canvas->LineTo(right,top);
// draw right edge
canvas->Pen->Color = cl3DDkShadow;
canvas->LineTo(right,bottom);
// draw bottom edge
canvas->LineTo(left-1,bottom);
// extra highlight
left++;
right--;
top++;
bottom--;
// draw left edge
canvas->Pen->Color = clBtnHighlight;
canvas->MoveTo(left, bottom);
canvas->LineTo(left, top);
// draw top edge
canvas->LineTo(right, top);
// draw right edge
canvas->Pen->Color = clBtnShadow;
canvas->MoveTo(right,top);
canvas->LineTo(right,bottom);
// draw bottom edge
canvas->LineTo(left-1,bottom);
}
//---------------------------------------------------------------------------
__fastcall TDDForm::TDDForm(TComponent* Owner)
	: TForm(Owner)
{
fLeft = Left;
fTop = Top;
fWidth = Width;
fHeight = Height;

fAnimationTicks = 0;
fFramesFlipped = 0;
fSeconds = 0;
fColor = 0;

fFormIsActive = false;
fHandlingWMPAINT = false;

flast_time = Time();
fPageNumber = 0;
fx = 0;
fy = 0;
fxincr = 1;
fyincr = 1;

if (DirectDraw == NULL) DirectDraw = new TDirectDraw(this);
if (DirectDraw != NULL) DirectDraw->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall 	TDDForm::~TDDForm()
{
if (DirectDraw != NULL)
	if (DirectDraw->Owner == this)
		{
	    delete DirectDraw;
	    DirectDraw = NULL;
	    }
}
//---------------------------------------------------------------------------
void ExcludeOtherForms( HWND Handle, HDC hdc )
{
// start at the z-factor of our current form
DirectDraw->Log(LOG_NOTE,"::WndProc","excluding other forms from clip region" );
HWND hwnd = GetWindow( Handle, GW_HWNDPREV );
int iter = 0;
// and scan through all other windows all higher z-factors
while (hwnd != NULL)
	{
    DirectDraw->Log(LOG_NOTE,"::WndProc","checking window #" + IntToStr(++iter) );
    // if it's not the current form (the one being drawn)
    if (hwnd != Handle)
    	{
		DirectDraw->Log(LOG_NOTE,"::WndProc","retrieved hwnd may be excluded");
        // determine the visibile state of the form
        TForm* form = NULL;
        for (int j=0;j<Screen->FormCount;j++)
        	if (Screen->Forms[j]->Handle == hwnd)
            	{
                form = Screen->Forms[j];
                j = Screen->FormCount+1;
                }
        bool form_is_visible = false;
        if (form != NULL) form_is_visible = form->Visible;

        // and if the form is visible
        if (form_is_visible)
        	{
	        DirectDraw->Log(LOG_NOTE,"::WndProc","excluding form :- '" + form->Caption + "'");
			DirectDraw->Log(LOG_NOTE,"::WndProc","excluding rect " + IntToStr(form->Left)+","+IntToStr(form->Top)+"-" + IntToStr(form->Left+form->Width)+","+IntToStr(form->Top+form->Height));
            // make sure not to paint over it...
			ExcludeClipRect( hdc, form->Left, form->Top, form->Left + form->Width, form->Top + form->Height );
            }
        else
        	{
            DirectDraw->Log(LOG_NOTE,"::WndProc","form is not visible");
            }
        }
    else
    	DirectDraw->Log(LOG_NOTE,"::WndProc","retrieved hwnd is current drawing window");

	// go to the next highest z-order
    hwnd = GetWindow( hwnd, GW_HWNDPREV );
    }
}
//---------------------------------------------------------------------------
void 	__fastcall TDDForm::WndProc(Messages::TMessage &Message)
{
if (DirectDraw != NULL)
	{
    if (!DirectDraw->Enabled)
    	{
        TForm::WndProc(Message);
        return;
        }
    }
else
	{
    TForm::WndProc(Message);
    return;
    }

// handle any repaint messages coming from Windows rather than letting the default
// WndProc function handle them as the default WndProc function automatically draws
// the form when receiving WM_PAINT, WM_NCPAINT, WM_NCACTIVATE.....
// since the form redrawing code uses a windows gdi Paint3d function which blits to
// the display on completion (we have no control over this), it is probably better
// to use our own handler so that we can control exactly when to blit what.

int		message = Message.Msg;
int		lparam	= Message.LParam;
int		wparam	= Message.WParam;

// pre-VCL message handling
switch (message)
	{
    case WM_ACTIVATE:

     	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","Receieved WM_ACTIVATE");

		// if we're possibly using DirectDraw stuff & we're not already handling a paint message
    	if ((DirectDraw != NULL) && !fHandlingWMPAINT)
        	{
        	if (!DirectDraw->Enabled) DirectDraw->Enabled = true;
            if (DirectDraw->Enabled)
            	{
    	        // make sure the GDI is the primary surface
	            DirectDraw->FlipToGDI();

				// copy what's currently displayed to our back buffer
	//			DirectDraw->Log(LOG_BEFORE,"<<FORM>>::WndProc()","DirectDraw->FlipGDIRectToBackBuffer()");
	//            DirectDraw->FlipGDIRectToBackBuffer(fLeft,fTop,fWidth,fHeight);
	//			DirectDraw->Log(LOG_AFTER,"<<FORM>>::WndProc()","DirectDraw->FlipGDIRectToBackBuffer()");

	            int active_flag = LOWORD(wparam);
	            fFormIsActive = ((active_flag == WA_ACTIVE) || (active_flag == WA_CLICKACTIVE));
	            Message.Msg = 0;
	 	        }
    		}
		// let the VCL handle the message as normal
        return;

	case WM_ERASEBKGND:
    	Message.Msg = 0;
        Message.Result = 0;
        return;
        
    case WM_NCPAINT:
    	Message.Msg = 0;
        return;
        
    case WM_PAINT:

    	// simply log all WM_PAINT messages for posterity
    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","Received WM_PAINT, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));

		// if we're possibly using DirectDraw stuff & we're not already handling a paint message
    	if ((DirectDraw != NULL) && !fHandlingWMPAINT)
        	// and DirectDraw stuff is enabled
            if (DirectDraw->Enabled)
	            {
		    	// simply log all WM_PAINT messages for posterity
		    	DirectDraw->Log(LOG_IN,"<<FORM>>::WndProc()","Painting form with DirectDraw");

                // set a flag so that we don't handle multiple WM_PAINT messages while
                // we're still handling the first WM_PAINT message (this can happen)
	            fHandlingWMPAINT = true;

				//
                //	paint the client area onto the back buffer DC
                //

		        // get a back buffer DC from DirectDraw if possible, NULL if not
                HDC hdc = DirectDraw->GetBackBufferDC();

    			// if the DC retrieved is valid
		        if (hdc != NULL)
		    	   	{
					// determine the bounds of the frame that we have to paint
					int borderx = GetSystemMetrics(SM_CXDLGFRAME);
					int bordery = GetSystemMetrics(SM_CYDLGFRAME);
					int captionheight = GetSystemMetrics(SM_CYCAPTION);

					RECT form_r;
					form_r.left = fLeft;
					form_r.top  = fTop;
                    form_r.right = fLeft+fWidth;
                    form_r.bottom = fTop+fHeight;

		            // tell windows that the region of the whole form (ie. including frame)
                    // is to be repainted (note: this sets the clip region to the whole form)
        			DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","telling windows to paint entire client area");
		            InvalidateRect(Handle,&form_r,false);

/*                    // scan through each of the other currently visible forms
                    // and exclude them from the current clip region
                    DirectDraw->Log(LOG_NOTE,"::WndProc","excluding other forms from clip region" );
                    for (int i=0;i<Screen->FormCount;i++)
                    	{
                        DirectDraw->Log(LOG_NOTE,"::WndProc","checking form #" + IntToStr(i) + "  ['" + Screen->Forms[i]->Name + "']" );
                        if (Screen->Forms[i]->Handle != Handle)
                        	{
                        	if (Screen->Forms[i]->Visible)
	                        	{
	                            DirectDraw->Log(LOG_NOTE,"WndProc","excluding form :- '" + Screen->Forms[i]->Name + "'");
                                TForm* form = Screen->Forms[i];
			                    DirectDraw->Log(LOG_NOTE,"::WndProc","excluding rect " + IntToStr(form->Left)+","+IntToStr(form->Top)+"-" + IntToStr(form->Left+form->Width)+","+IntToStr(form->Top+form->Height));
								ExcludeClipRect( hdc, form->Left, form->Top, form->Left + form->Width, form->Top + form->Height );
	                            }
                            else
                            	DirectDraw->Log(LOG_NOTE,"::WndProc","form '" + Screen->Forms[i]->Name + "' not visible, not being excluded");
                            }
                        else
                          	DirectDraw->Log(LOG_NOTE,"::WndProc","skipping form '" + Screen->Forms[i]->Name + "' because it's the one being drawn" );
                        }
					IntersectClipRect( hdc, Screen->ActiveForm->Left, Screen->ActiveForm->Top, Screen->ActiveForm->Left + Screen->ActiveForm->Width, Screen->ActiveForm->Top + Screen->ActiveForm->Height );
*/
					ExcludeOtherForms( Handle, hdc );

                    // paint the frame
                    PaintFrame(hdc);

                    // determine the client area just inside the frame
                    RECT client_r = form_r;
                    if (BorderStyle != bsNone)
                    	{
                        client_r.left += borderx;
    					client_r.top += bordery + captionheight;
                        client_r.right -= borderx;
                        client_r.bottom -= bordery;
                        }

                    // adjust the clip rect so that all drawing is clipped to the client area
        			DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","setting clip region to client area");
                    HRGN client_hrgn = CreateRectRgn( client_r.left, client_r.top, client_r.right, client_r.bottom );
                    int result = SelectClipRgn( hdc, client_hrgn );
                    DeleteObject( client_hrgn );

					ExcludeOtherForms( Handle, hdc );

                    // move the draw start location to the top,left of the form's client area
        			DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","moving window origin to top,left of client area");
				    MoveWindowOrg( hdc, client_r.left, client_r.top );

        			DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","clearing whats already under the client area");
                    try
                    	{
                        Canvas->Handle = hdc;
						Canvas->Brush->Color = Color;
						Canvas->Brush->Style = bsSolid;
						Canvas->FillRect( ClientRect );
                        }
                    catch ( ... ) {}
					Canvas->Handle = NULL;

	                // paint the contents of the form, including all controls
        			DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","painting window, controls, etc.");
	                Messages::TWMPaint	MyPaintMessage;
	                MyPaintMessage.Msg = WM_PAINT;
	                MyPaintMessage.DC  = hdc;
	                MyPaintMessage.Unused = 0;
	                MyPaintMessage.Result = 0;
	                PaintHandler(MyPaintMessage);

                    // reset the DC's window paint origin
        			DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","moving window origin to top,left of entire screen");
				    MoveWindowOrg( hdc, -client_r.left, -client_r.top );

				    // release the DirectX supplied DC
        			DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","releasing back buffer DC");
					DirectDraw->ReleaseBackBufferDC();
	                hdc = NULL;

                    // figure out the region that we want to blit (area that was just painted)
        			DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","setting clip region to client area");

        			DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","flipping client area to display");
					fFramesFlipped++;
//                DirectDraw->FlipBackBufferToGDI();
                   	DirectDraw->FlipBackBufferRectToGDI(form_r.left,form_r.top,form_r.right-form_r.left,form_r.bottom-form_r.top);

		            // tell windows that the entire form has been repainted
		            ValidateRect(Handle,NULL);
		            }

                // reset the flag used to stop multiple WM_PAINT messages while
                // we're still handling the first WM_PAINT message (this can happen)
		        fHandlingWMPAINT = false;
	            DirectDraw->Log(LOG_OUT,"<<FORM>>::WndProc()","WM_PAINT");

		        // clear the Message so that the VCL does nothing else
		        Message.Msg = 0;
	            }
		// let the VCL handle the message as normal
        return;

	case WM_DRAWITEM:

		// only modify behaviour when using DirectDraw stuff, otherwise drop through to
        // the VCL default WndProc()
    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_DRAWITEM, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
//		lpdraw = (LPDRAWITEMSTRUCT) Message.LParam;
//		if (lpdraw->CtlType == ODT_LISTBOX) return;
		break;

   	// don't log any messages for WM_MEASUREITEM messages
    case WM_MEASUREITEM:

       	DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()>>>>>>>>>>>","Received WM_MEASUREITEM, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

    // simply log the various messages for debugging purposes
    case WM_VSCROLL:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_VSCROLL, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

    case WM_HSCROLL:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_HSCROLL, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
    	break;

	case WM_NCCALCSIZE:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_NCCALCSIZE, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_COMMAND:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_COMMAND, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_GETTEXT:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_GETTEXT, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_GETTEXTLENGTH:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_GETTEXTLENGTH, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLORMSGBOX:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLORMSGBOX, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLOREDIT:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLOREDIT, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
/*     	{
    	HWND hwnd = (HWND) lparam;
        HDC  hdc  = (HDC)  wparam;
        for (int i=0; i<ControlCount; i++)
        	{

		    // figure out if the class is based on TWinControl (if so, it may require a border).
		    // this is done by traversing the ancestor classes of the control until we find a
		    // TWinControl parent, or till we run out of parents
		    TClass	theclass = Controls[i]->ClassType();
		    bool 	isWinControl = false;
			while	(theclass != NULL)
				{
			    System::AnsiString	class_name = theclass->ClassName();
		        if (class_name == "TWinControl")
		        	{
		            isWinControl = true;
		            break;
		            }
				theclass = theclass->ClassParent();
				}
			if (isWinControl)
            	{
                TWinControl* control = (TWinControl*) Controls[i];
                if (control->Handle == hwnd)
	            	{
	                TEdit* edit = (TEdit*) control;
	                SetBkColor( hdc, ColorToRGB(edit->Color) );
	                SetTextColor( hdc, ColorToRGB(edit->Font->Color) );
                    Message.Result = (long) Brush->Handle;
	                return;
	                }
                }
            }
        }
*/        break;

	case WM_CTLCOLORLISTBOX:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLORLISTBOX, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLORBTN:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLORBTN, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLORDLG:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLORDLG, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLORSCROLLBAR:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLORSCROLLBAR, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLORSTATIC:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLORSTATIC, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_NCHITTEST:
                             
//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_NCHITTEST, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case CM_CURSORCHANGED:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_CURSORCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case CM_FONTCHANGED:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_FONTCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case CN_DRAWITEM:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_DRAWITEM, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_SETCURSOR:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_SETCURSOR, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_MOUSEFIRST:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_MOUSEFIRST, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_NCMOUSEMOVE:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_NCMOUSEMOVE, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_CAPTURECHANGED:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CAPTURECHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_SYSCOMMAND:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_SYSCOMMAND, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_NCLBUTTONDOWN:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_NCLBUTTONDOWN, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_GETMINMAXINFO:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_GETMINMAXINFO, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_MOVE:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_MOVE, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
/*    	if ((DirectDraw != NULL) && !fHandlingWMPAINT)
        	{
            InvalidateRect( Handle, NULL, false );
            HDC hdc = DirectDraw->GetBackBufferDC();
            if (hdc != NULL)
            	{
                SelectClipRgn( hdc, NULL );
                DirectDraw->ReleaseBackBufferDC();
                }
	        ValidateRect(Handle,NULL);
//		    fLeft = LOWORD(lparam);
//	        fTop  = HIWORD(lparam);
//			Perform( WM_PAINT, 0, NULL );
        	}
*/        break;

	case WM_SIZE:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_SIZE, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
/*    	if ((DirectDraw != NULL) && !fHandlingWMPAINT)
        	{
//	    	fWidth = LOWORD(lparam);
//	        fHeight  = HIWORD(lparam);
//        	Perform( WM_PAINT, 0, NULL );
  			}
*/        break;

	case WM_WINDOWPOSCHANGING:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_WINDOWPOSCHANGING, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_WINDOWPOSCHANGED:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_WINDOWPOSCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLORBTN:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLORBTN, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLORDLG:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLORDLG, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLOREDIT:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLOREDIT, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLORLISTBOX:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLORLISTBOX, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLORMSGBOX:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLORMSGBOX, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLORSCROLLBAR:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLORSCROLLBAR, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLORSTATIC:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLORSTATIC, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_DIALOGKEY:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_DIALOGKEY, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_DIALOGCHAR:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_DIALOGCHAR, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_CHILDKEY:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_CHILDKEY, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_SYSKEYUP:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_SYSKEYUP, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_SYSKEYDOWN:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_SYSKEYDOWN, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_PARENTNOTIFY:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_PARENTNOTIFY, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_MOUSEACTIVATE:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_MOUSEACTIVATE, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_FOCUSCHANGED:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_FOCUSCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_CTLCOLORMSGBOX-1:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLOR??????, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_PARENTSHOWHINTCHANGED:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_PARENTSHOWHINTCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_SETFOCUS:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_SETFOCUS, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_ICONCHANGED:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_ICONCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_KEYUP:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_KEYUP, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_SYSKEYDOWN:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_SYSKEYDOWN, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_NOTIFY:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_NOTIFY, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_SYSCHAR:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_SYSCHAR, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_KEYDOWN:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_KEYDOWN, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_ENABLEDCHANGED:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_ENABLEDCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_CTL3DCHANGED:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_CTL3DCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

    default:

    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","unknown message " + IntToStr(message));
        break;
    }

// let the VCL handle the message
TForm::WndProc(Message);
Message.Msg = 0;

// post-VCL message handling
switch (message)
	{
    case WM_ACTIVATE:
//    	fFormIsActive = Active;
        break;

//    case WM_WINDOWPOSCHANGING:
    case WM_WINDOWPOSCHANGED:

//    	if (FormIsActive) Perform( WM_PAINT, 0, NULL );
        break;

	case WM_NCACTIVATE:
		fFormIsActive = Active;
        
	case WM_NCPAINT:

    	if (fFormIsActive) Perform( WM_PAINT, 0, NULL );
        break;

    case WM_SIZE:
    case WM_MOVE:

        fWidth = Width;
		fHeight = Height;
		fLeft = Left;
		fTop = Top;
    	if (fFormIsActive) Perform( WM_PAINT, 0, NULL );
        break;

    case WM_MOUSEMOVE:

//    	if (DirectDraw != NULL) DirectDraw->DrawMouseCursor();
        break;

    case WM_SETCURSOR:
    case WM_NCMOUSEMOVE:

//    	if (DirectDraw != NULL) DirectDraw->DrawMouseCursor();
        break;

    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::PaintHandler(Messages::TWMPaint &Message)
{
// simply check our preconditions & skip out if not appropriate
if (DirectDraw != NULL)
	{
	if (!DirectDraw->Enabled)
    	{
	    TForm::PaintHandler(Message);
	    return;
	    }
    }
else
	{
	TForm::PaintHandler(Message);
    return;
    }

DirectDraw->Log(LOG_IN,"<<FORM>>::PaintHandler()","");

// if the supplied DC is okay
HDC hdc = Message.DC;
// use standard function calls to paint to our DirectX surface
try
  	{
    int	SaveIndex;
    int Clip;

    if (ControlCount==0)
    	{
		DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintHandler()","no controls, simply painting window");
        PaintWindow(hdc);
        }
    else
    	{
		DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintHandler()","has controls, calculating clip extent");
        SaveIndex = SaveDC( hdc );
	    Clip = SIMPLEREGION;
        for (int i=0;i<ControlCount;i++)
			{
            bool control_is_visible = Controls[i]->Visible;
		    bool control_design_visible = !Controls[i]->ControlStyle.Contains(csNoDesignVisible);

		   	if (control_is_visible && control_design_visible)
				{
	            Clip = ExcludeClipRect( hdc, Controls[i]->Left,
	            							 Controls[i]->Top,
	            							 Controls[i]->Left + Controls[i]->Width,
	                                         Controls[i]->Top + Controls[i]->Height );
	            if (Clip == NULLREGION) break;
	            }
            }
        if (Clip != NULLREGION)
        	{
			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintHandler()","clip region is not null, painting window");
            PaintWindow( hdc );
            }
        else
   			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintHandler()","clip region is null, NOT painting window");

        RestoreDC( hdc, SaveIndex );
        }
	DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintHandler()","painting controls");
    PaintControls( hdc, NULL );
	}
// unless a problem occurs
catch (...)
	{
	DirectDraw->Log(LOG_OUT,"<<FORM>>::PaintHandler()","VCL paint on DirectX DC - NOT SUCCESSFUL!");
	}
}
//---------------------------------------------------------------------------
void	__fastcall	TDDForm::PaintWindow(HDC hdc)
{
if (hdc == NULL) return;
if ((DirectDraw != NULL) && fHandlingWMPAINT)
	{
	if (!DirectDraw->Enabled)
    	{
	    TForm::PaintWindow(hdc);
	    return;
	    }
    }
else
	{
	TForm::PaintWindow(hdc);
    return;
    }

DirectDraw->Log(LOG_IN,"<<FORM>>::PaintWindow()","");

Canvas->Handle = NULL;
try
	{
    Canvas->Handle = hdc;
    Paint();
    }
catch ( ... ) {}
// always release anything that might have been allocated in Paint()
Canvas->Handle = NULL;

DirectDraw->Log(LOG_OUT,"<<FORM>>::PaintWindow()","");
}
//---------------------------------------------------------------------------
void	__fastcall	TDDForm::PaintControls(HDC hdc, TControl* First)
{
// simply check our preconditions & skip out if not appropriate
if (hdc == NULL) return;
if ((DirectDraw != NULL) && fHandlingWMPAINT)
	{
	if (!DirectDraw->Enabled)
    	{
	    TForm::PaintControls(hdc,First);
	    return;
	    }
    }
else
	{
	TForm::PaintControls(hdc,First);
    return;
    }
    
DirectDraw->Log(LOG_IN,"<<FORM>>::PaintControls()","");
if (ControlCount == 0)
	{
	DirectDraw->Log(LOG_OUT,"<<FORM>>::PaintControls()","ControlCount is 0");
    return;
    }

// quickly scan the controls until we get to the first control, then fall through with the
// value of the first control in "i" (defaulting at zero if First parameter is NULL)
// ; also determine how many controls are meant to be repainted
int controls_to_paint = ControlCount;
int i = 0;
int j = 0;
if (First != NULL)
	{
    controls_to_paint = 1;
	while (j<ControlCount)
	   	{
		if (Controls[j] == First) i = j;
	    j++;
	    }
    }

int k = 0;
while (k<controls_to_paint)
	{
    // use mapped variables
    TControl* control = Controls[i];
	DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","painting control '" + control->Name + "'");

    // figure out if the class is based on TWinControl (if so, it may require a border).
    // this is done by traversing the ancestor classes of the control until we find a
    // TWinControl parent, or till we run out of parents
    TClass	theclass = control->ClassType();
    bool 	isWinControl = false;
    bool	isScrollingWinControl = false;
    bool	isListBox = false;
	while	(theclass != NULL)
		{
	    System::AnsiString	class_name = theclass->ClassName();
        if (class_name == "TScrollingWinControl")
        	{
            isScrollingWinControl = true;
            break;
            }
        if (class_name == "TListBox")
        	{
            isListBox = true;
            break;
            }
        if (class_name == "TWinControl")
        	{
            isWinControl = true;
            break;
            }
		theclass = theclass->ClassParent();
		}

    RECT control_r;
    control_r.left = control->Left;
    control_r.top = control->Top;
    control_r.right = control_r.left + control->Width;
    control_r.bottom = control_r.top + control->Height;

	bool control_is_transparent = !control->ControlStyle.Contains(csOpaque);
    bool control_is_framed = control->ControlStyle.Contains(csFramed);
    bool control_is_visible = control->Visible;
    bool control_design_visible = !control->ControlStyle.Contains(csNoDesignVisible);
    bool control_rect_visible = RectVisible( hdc, &control_r );

   	if (control_is_visible && control_design_visible && control_rect_visible)
    	{
	    if (ControlState.Contains(csPaintCopy)) control->ControlState >> csPaintCopy;

	    int SaveIndex = SaveDC( hdc );
		DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","moving window origin to control origin");
	    MoveWindowOrg( hdc, control->Left, control->Top );
		DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","intersecting current clip rect with control rect");
	    IntersectClipRect( hdc, 0, 0, control->Width, control->Height );
		DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","telling control to erase background");

		if (isScrollingWinControl)
        	{
			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","Painting TSCROLLINGWINCONTROL");
            TScrollingWinControl* scrollingwincontrol = (TScrollingWinControl*) control;
            scrollingwincontrol->PaintTo(hdc,0,0);
            TControlScrollBar* scrollbar = scrollingwincontrol->HorzScrollBar;
            if (scrollbar->Visible)
            	{
//				scrollbar->PaintTo(hdc, scrollingwincontrol->Width - scrollbar->Width, 0 );
                }
            scrollbar = scrollingwincontrol->VertScrollBar;
//            if (scrollbar->Visible)
            	{
                // vertical scroll bar
                int scrollbarwidth = GetSystemMetrics( SM_CXHSCROLL );
                int scrollbarheight = GetSystemMetrics( SM_CYHSCROLL );
                int thumbheight = GetSystemMetrics( SM_CXHTHUMB );
				int iconwidth = GetSystemMetrics( SM_CXSMICON );
                int iconheight = GetSystemMetrics( SM_CYSMICON );

                int top = 0;
                int left = scrollingwincontrol->Width - scrollbarwidth;

                try
                	{
					Canvas->Handle = hdc;
					Graphics::TBitmap* bitmap = new Graphics::TBitmap();
				    if (bitmap != NULL)
				    	{
					    bitmap->IgnorePalette = true;
						bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_UPARROW) );
						Canvas->Draw( left, top, bitmap );
					    bitmap->Handle = NULL;
						top = scrollingwincontrol->Height - scrollbarheight;
						bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_DNARROW) );
						Canvas->Draw( left, top, bitmap );
					    bitmap->Handle = NULL;
	                    top = 0 + iconheight + scrollbar->Position / scrollbar->Range;
	                    Canvas->Pen->Color = clRed;
    	                Canvas->Pen->Width = 1;
	                    Canvas->Brush->Color = clRed;
	                    Canvas->Brush->Style = bsSolid;
	                    Canvas->Rectangle( left, top, left + iconwidth, top + iconheight );
						delete bitmap;
				        }
                    }
                catch ( ... ) {}
                Canvas->Handle = NULL;
                }
            }
        else
        if (isListBox)
        	{
			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","Painting TSCROLLINGWINCONTROL");
            TListBox* listbox = (TListBox*) control;
            listbox->Canvas->Handle = hdc;
            listbox->PaintTo(hdc,0,0);
            listbox->Canvas->Handle = NULL;

            SCROLLINFO	scrollinfo;
            scrollinfo.cbSize = sizeof(SCROLLINFO);
            scrollinfo.fMask = SIF_ALL;
			bool info_retrieved = (GetScrollInfo( listbox->Handle, SB_VERT, &scrollinfo ) != 0);
            int rowsperpage = scrollinfo.nPage;
            int maxrows = rowsperpage;
            if (!listbox->IntegralHeight) maxrows++;
            // if the info retrieved was valid
            if (info_retrieved && (listbox->Items->Count>maxrows))
            	{
                // vertical scroll bar
	            int scrollbarpos = GetScrollPos( listbox->Handle, SB_VERT );
                int scrollbarwidth = GetSystemMetrics( SM_CXHSCROLL );
                int scrollbarheight = GetSystemMetrics( SM_CYHSCROLL );
                int thumbheight = GetSystemMetrics( SM_CXHTHUMB );
				int iconwidth = GetSystemMetrics( SM_CXSMICON );
                int iconheight = GetSystemMetrics( SM_CYSMICON );

                int top = 2;
                int left = listbox->Width - scrollbarwidth - 2;

                try
                	{
					Canvas->Handle = hdc;
					Graphics::TBitmap* bitmap = new Graphics::TBitmap();
				    if (bitmap != NULL)
				    	{
                        // figure some simple values
		                int itemindex = listbox->ItemIndex;
                        int topofuparrow = top;
                        int bottomofuparrow = top + iconheight;
                        int topofdnarrow = listbox->Height - scrollbarheight - 2;
						int bottomofdnarrow = listbox->Height - 2;
                        int topofthumbnailarea = bottomofuparrow-2;
                        int bottomofthumbnailarea = topofdnarrow+1;
                        // draw under the thumbnail
                        Canvas->Pen->Style = psClear;
                        Canvas->Pen->Color = clScrollBar;
                        Canvas->Brush->Style = bsSolid;
						Canvas->Brush->Color = clScrollBar;
                        Canvas->Rectangle( left, topofthumbnailarea, left + iconwidth - 1, bottomofthumbnailarea );
                        // draw up arrow
					    bitmap->IgnorePalette = true;
						bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_UPARROW) );
						Canvas->Draw( left, topofuparrow, bitmap );
					    bitmap->Handle = NULL;
						// draw down arrow
						bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_DNARROW) );
						Canvas->Draw( left, topofdnarrow, bitmap );
					    bitmap->Handle = NULL;
						delete bitmap;

						// draw the thumbnail
                        int pixelheight = bottomofthumbnailarea - topofthumbnailarea;
                        int rowheight = listbox->ItemHeight;
                        int totalrows = scrollinfo.nMax - scrollinfo.nMin + 1;
                        int topofthumbnail = topofthumbnailarea;
                        int thumbnailheight = 0;
                        if (totalrows != 0)
                        	{
                            thumbnailheight += (int)(((float)pixelheight * (float)rowsperpage) / (float)totalrows);
                            topofthumbnail += (int)(((float)pixelheight * (float)scrollbarpos) / (float)totalrows);
	                        if (scrollbarpos+rowsperpage >= totalrows) topofthumbnail--;
                            }
                        if (thumbnailheight<8) thumbnailheight=8;

                        DirectDraw->Log(LOG_NOTE,"===============","scrollbarpos == " + IntToStr(scrollbarpos));
                        DirectDraw->Log(LOG_NOTE,"===============","pixelheight == " + IntToStr(pixelheight));
                        DirectDraw->Log(LOG_NOTE,"===============","rowheight == " + IntToStr(rowheight));
                        DirectDraw->Log(LOG_NOTE,"===============","rowsperpage == " + IntToStr(rowsperpage));
                        DirectDraw->Log(LOG_NOTE,"===============","totalrows == " + IntToStr(totalrows));
                        DirectDraw->Log(LOG_NOTE,"===============","itemindex == " + IntToStr(itemindex));
                        DirectDraw->Log(LOG_NOTE,"===============","topofthumbnail == " + IntToStr(topofthumbnail));

                        MyFrame3DThumbnail( Canvas, left, topofthumbnail, left + iconwidth - 3, topofthumbnail + thumbnailheight - 1);

                        // draw the currently highlighted selections iff required
                        if (listbox->ItemIndex != -1)
                        	{
                            // draw the rows of displayed text
                            Canvas->Pen->Style = psClear;
		                    Canvas->Brush->Style = bsSolid;

							for (int row=0;row<maxrows;row++)
                            	{
                                int rowindex = scrollbarpos + row;
                                if (rowindex>listbox->Items->Count-1) break;

	                            // draw the text for the highlight
	                            TRect r;
	                            r.Left = 2;
	                            r.Right = left;
	                            r.Top = row * rowheight + 2;
	                            r.Bottom = r.Top + rowheight;
                                if (r.Top>=listbox->Height-7) break;
                                if (r.Bottom-r.Top>=listbox->Height-7) r.Bottom = r.Top + listbox->Height-7;
	                            Canvas->Font->Name = listbox->Font->Name;
	                            Canvas->Font->Style = listbox->Font->Style >> fsBold >> fsItalic >> fsUnderline;
	                            Canvas->Font->Size = listbox->Font->Size;
			                    if (listbox->Selected[rowindex])
                                	{
                                    Canvas->Font->Color = clWindow;
                                    Canvas->Brush->Color = clActiveCaption;
		                            Canvas->TextRect( r, r.Left+2, r.Top, listbox->Items->Strings[rowindex] );
                                    }
                                else
                                	{
                                    Canvas->Font->Color = listbox->Font->Color;
                                    Canvas->Brush->Color = listbox->Color;
		                            Canvas->TextRect( r, r.Left+2, r.Top, listbox->Items->Strings[rowindex] );
                                    }

	                        	// draw the current row highlight as well
                                if (listbox->Selected[rowindex] && (listbox->ItemIndex == rowindex) && (Screen->ActiveControl==listbox))
                                	{
		                            int i;
		                            int even = listbox->ItemIndex % 2;
	                                int rtop = r.Top;
	                                int rleft = r.Left;
	                                int rright = r.Right-1;
	                                int rbottom = r.Bottom-1;

	                                if (even)
	                                	{
			                            for (i=rleft;i<rright;i+=2)
	                                    	{
		                                    Canvas->Pixels[i][rtop] = clWindow;
	                                        Canvas->Pixels[i][rbottom] = clWindow;
	   	                                    }
			                            for (i=rtop;i<rbottom;i+=2)
	                                    	{
		                                    Canvas->Pixels[rleft][i] = clWindow;
	                                        Canvas->Pixels[rright][i] = clWindow;
	   	                                    }
                                        Canvas->Pixels[rright][rbottom] = clWindow;
	                                    }
	                                else
	                                	{
			                            for (i=rleft+1;i<rright;i+=2)
	                                    	{
		                                    Canvas->Pixels[i][rtop] = clWindow;
	                                        Canvas->Pixels[i][rbottom] = clWindow;
	   	                                    }
			                            for (i=rtop+1;i<rbottom;i+=2)
	                                    	{
		                                    Canvas->Pixels[rleft][i] = clWindow;
	                                        Canvas->Pixels[rright][i] = clWindow;
	   	                                    }
	                                    }
                                    }
	                            }
                            }
				        }
                    }
                catch ( ... ) {}
                Canvas->Handle = NULL;
                }
            }
        else
        // derived from TWinControl
        if (isWinControl)
        	{
			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","Painting WINCONTROL");
            TWinControl* wincontrol = (TWinControl*) control;
            wincontrol->PaintTo(hdc,0,0);
            }
        else
        	// normal controls
        	{
//		    control->Perform( WM_ERASEBKGND, (long) hdc, NULL );
//			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","telling control to paint");
		    control->Perform( WM_PAINT, (long) hdc, NULL );
			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","control '" + control->Name + "' was painted");
            }

	    RestoreDC( hdc, SaveIndex );
	    if (ControlState.Contains(csPaintCopy)) control->ControlState << csPaintCopy;
        }

	// choose the next control
    ++i %= ControlCount;	// wrap to 0..ControlCount-1
    k++;
    }

// debugging
DirectDraw->Log(LOG_OUT,"<<FORM>>::PaintControls()","painted " + IntToStr(k) + " controls");
}
//---------------------------------------------------------------------------
void	__fastcall TDDForm::Repaint()
{
if (DirectDraw != NULL)
	{
	if (!DirectDraw->Enabled)
    	{
        TForm::Repaint();
        return;
        }
    }
else
	{
	TForm::Repaint();
    return;
    }

if (Visible)
	{
    InvalidateRect(Handle,NULL,false);
    UpdateWindow(Handle);
    }
}
//---------------------------------------------------------------------------
void	__fastcall TDDForm::PaintFrame(HDC hdc)
{
// skip out if invalid DC
if (hdc == NULL) return;
if (DirectDraw == NULL) return;

DirectDraw->Log(LOG_IN,"<<FORM>>::PaintFrame()","");

// get some standard element sizes from windows
int borderx = GetSystemMetrics(SM_CXDLGFRAME);
int bordery = GetSystemMetrics(SM_CYDLGFRAME);
int captionheight = GetSystemMetrics(SM_CYCAPTION);
int buttonwidth = GetSystemMetrics(SM_CXSMICON);
int buttonheight = GetSystemMetrics(SM_CYSMICON);
int x,y;

// set the canvas to paint on the supplied DC
Canvas->Handle = hdc;

int left = Left-1;
int top = Top-1;
int right = Left+Width+1;
int bottom = Top+Height+1;

// draw a 3d frame round the entire form
MyFrame3DWindow( Canvas, left, top, right, bottom, 4 );

// figure out the region in the caption area with the in/active caption color
TRect	caption_r;
caption_r.Left = Left + borderx;
caption_r.Top  = Top + bordery;
caption_r.Right = Left+Width - borderx;
caption_r.Bottom = caption_r.Top + captionheight-1;

// fill in the caption area with the active caption color
if (fFormIsActive) Canvas->Brush->Color = clActiveCaption;
else Canvas->Brush->Color = clInactiveCaption;
Canvas->Brush->Style = bsSolid;
Canvas->FillRect( caption_r );

// draw line between caption bar and main draw area
Canvas->Pen->Color = clBtnFace;
Canvas->Pen->Width = bordery;
Canvas->MoveTo(caption_r.Left, caption_r.Bottom + 1);
Canvas->LineTo(caption_r.Right, caption_r.Bottom + 1);

// draw the form's caption
if (fFormIsActive) Canvas->Brush->Color = clActiveCaption;
else Canvas->Brush->Color = clInactiveCaption;
Canvas->Font->Height = captionheight-bordery-3;
Canvas->Font->Color = clCaptionText;//Font->Color;
Canvas->Font->Style = Canvas->Font->Style << fsBold;
Canvas->Font->Name = "SYSTEM_FONT";//"Arrus BT";//"Bookman Old Style";//"Bookman Antiqua";//"MS Shell Dlg";//Font->Name;
TRect text_r;
text_r.Left = caption_r.Left+borderx+buttonwidth+2;
text_r.Right = caption_r.Right-4*buttonwidth+borderx+2;
text_r.Top = caption_r.Top+3;
text_r.Bottom = caption_r.Bottom-bordery;
Canvas->TextRect( text_r, text_r.Left, text_r.Top, Caption );//caption_r.Left + borderx + buttonwidth+2,caption_r.Top+3, Caption );

// draw the "command" button on the top,left of the caption area
TRect bitmap_r;
bitmap_r.Left = caption_r.Left + borderx;
bitmap_r.Right = bitmap_r.Left + buttonwidth - 1;
bitmap_r.Top = caption_r.Top + 2;
bitmap_r.Bottom = bitmap_r.Top + buttonheight - 2;

Graphics::TBitmap* bitmap = new Graphics::TBitmap();
if (bitmap != NULL)
	{
    bitmap->IgnorePalette = false;
    bitmap->Width = Application->Icon->Width;
    bitmap->Height = Application->Icon->Height;
	bitmap->Canvas->Draw( 0, 0, Application->Icon );

    bitmap_r.Left--;
    bitmap_r.Top--;
    bitmap_r.Bottom++;
	Canvas->StretchDraw( bitmap_r, bitmap );
	delete bitmap;
    }

/////// draw the "close window" button (ie. "X" on top,right corner)
bitmap_r.Right = caption_r.Right - borderx;
bitmap_r.Left = bitmap_r.Right - buttonwidth + 1;
bitmap_r.Top = caption_r.Top + 2;
bitmap_r.Bottom = bitmap_r.Top + buttonheight - 3;

Canvas->Brush->Color = clBtnFace;
Canvas->Pen->Style = psClear;
Canvas->Rectangle( bitmap_r.Left, bitmap_r.Top, bitmap_r.Right+1, bitmap_r.Bottom+1 );

MyFrame3DButton( Canvas, bitmap_r.Left, bitmap_r.Top, bitmap_r.Right, bitmap_r.Bottom);

Canvas->Pen->Color = cl3DDkShadow;
Canvas->Pen->Width = 1;
Canvas->Pen->Style = psSolid;

// top-left to bottom-right
// centre
Canvas->MoveTo( bitmap_r.Left + 5, bitmap_r.Top + 4 );
Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 12 );
// left of centre
Canvas->MoveTo( bitmap_r.Left + 5, bitmap_r.Top + 5 );
Canvas->LineTo( bitmap_r.Left + 12, bitmap_r.Top + 12 );
// right of centre
Canvas->MoveTo( bitmap_r.Left + 6, bitmap_r.Top + 4 );
Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 11 );

// top-right to bottom-left
// centre
Canvas->MoveTo( bitmap_r.Left + 12, bitmap_r.Top + 4 );
Canvas->LineTo( bitmap_r.Left + 4, bitmap_r.Top + 12 );

// left of centre
Canvas->MoveTo( bitmap_r.Left + 11, bitmap_r.Top + 4 );
Canvas->LineTo( bitmap_r.Left + 4, bitmap_r.Top + 11 );

// right of centre
Canvas->MoveTo( bitmap_r.Left + 12, bitmap_r.Top + 5 );
Canvas->LineTo( bitmap_r.Left + 5, bitmap_r.Top + 12 );


///////////////////////////////////////////////////////////////////////////////////
// DEBUG this bit of code gets all available "standard" windows 95 system bitmaps
// such as OBM_CLOSE, OBM_MINIMIZE, etc. (used in drawing frames obviously)....
// however, the bitmaps returned require too much manipulation before they look normal
// even though these bitmaps were manipulated correctly, I've elected to draw make the
// code simpler by drawing them manually.
/*
int g;
for (g=0;g<21;g++)
	{
	bitmap = new Graphics::TBitmap();
    if (bitmap != NULL)
    	{
	    bitmap->IgnorePalette = true;
		bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_CLOSE-g) );
		Canvas->Draw( 16 , g * 24, bitmap );
	    bitmap->Handle = NULL;
		delete bitmap;
        }
    }
*/
///////////////////////////////////////////////////////////////////////////////////


// draw the "maximize window" button
bitmap_r.Left -= (buttonwidth + 2);
bitmap_r.Right -= (buttonwidth + 2);
if (WindowState==wsMaximized)
	{
	Canvas->Brush->Color = clBtnFace;
	Canvas->Pen->Style = psClear;
	Canvas->Rectangle( bitmap_r.Left, bitmap_r.Top, bitmap_r.Right+1, bitmap_r.Bottom+1 );

	MyFrame3DButton( Canvas, bitmap_r.Left, bitmap_r.Top, bitmap_r.Right, bitmap_r.Bottom);

	bool restore_active = (BorderIcons.Contains(biMaximize));
	if (restore_active) Canvas->Pen->Color = cl3DDkShadow;
	else Canvas->Pen->Color = clBtnShadow;
	Canvas->Pen->Width = 1;
	Canvas->Pen->Style = psSolid;

	// top-middle to top-right
	Canvas->MoveTo( bitmap_r.Left + 6, bitmap_r.Top + 3 );
	Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 3 );
	Canvas->MoveTo( bitmap_r.Left + 6, bitmap_r.Top + 4 );
	Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 4 );
    // middle-left to middle-middle
	Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 6 );
	Canvas->LineTo( bitmap_r.Left + 11, bitmap_r.Top + 6 );
	Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 7 );
	Canvas->LineTo( bitmap_r.Left + 11, bitmap_r.Top + 7 );
	// bottom-left box
	Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 8 );
	Canvas->LineTo( bitmap_r.Left + 4, bitmap_r.Top + 11 );
	Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 11 );
	Canvas->LineTo( bitmap_r.Left + 10, bitmap_r.Top + 11 );
	Canvas->MoveTo( bitmap_r.Left + 10, bitmap_r.Top + 8 );
	Canvas->LineTo( bitmap_r.Left + 10, bitmap_r.Top + 12 );
	// top-right box
	Canvas->MoveTo( bitmap_r.Left + 6, bitmap_r.Top + 5 );
	Canvas->LineTo( bitmap_r.Left + 6, bitmap_r.Top + 7 );
	Canvas->MoveTo( bitmap_r.Left + 12, bitmap_r.Top + 5 );
	Canvas->LineTo( bitmap_r.Left + 12, bitmap_r.Top + 9 );
	Canvas->MoveTo( bitmap_r.Left + 10, bitmap_r.Top + 8 );
	Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 8 );
    }
else
	{
	Canvas->Brush->Color = clBtnFace;
	Canvas->Pen->Style = psClear;
	Canvas->Rectangle( bitmap_r.Left, bitmap_r.Top, bitmap_r.Right+1, bitmap_r.Bottom+1 );

	MyFrame3DButton( Canvas, bitmap_r.Left, bitmap_r.Top, bitmap_r.Right, bitmap_r.Bottom);

	bool maximize_active = (BorderIcons.Contains(biMaximize));
	if (maximize_active) Canvas->Pen->Color = cl3DDkShadow;
	else Canvas->Pen->Color = clBtnShadow;

	Canvas->Pen->Width = 1;
	Canvas->Pen->Style = psSolid;

	// top-left to top-right
	Canvas->MoveTo( bitmap_r.Left + 3, bitmap_r.Top + 3 );
	Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 3 );
	Canvas->MoveTo( bitmap_r.Left + 3, bitmap_r.Top + 4 );
	Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 4 );
	// left
	Canvas->MoveTo( bitmap_r.Left + 3, bitmap_r.Top + 5 );
	Canvas->LineTo( bitmap_r.Left + 3, bitmap_r.Top + 11 );
	// right
	Canvas->MoveTo( bitmap_r.Left + 12, bitmap_r.Top + 5 );
	Canvas->LineTo( bitmap_r.Left + 12, bitmap_r.Top + 11 );
	// bottom
	Canvas->MoveTo( bitmap_r.Left + 3, bitmap_r.Top + 11 );
	Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 11 );

    // add highlights to not-available icon
    if (!maximize_active)
    	{
		Canvas->Pen->Color = clBtnHighlight;
        // top
        Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 5 );
        Canvas->LineTo( bitmap_r.Left + 12, bitmap_r.Top + 5 );
        // left
        Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 5 );
        Canvas->LineTo( bitmap_r.Left + 4, bitmap_r.Top + 11 );
        // right
        Canvas->MoveTo( bitmap_r.Left + 13, bitmap_r.Top + 4 );
        Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 12 );
        // bottom
        Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 12 );
        Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 12 );
        }
    }

// draw the "minimize window" button
bitmap_r.Left -= buttonwidth;
bitmap_r.Right -= buttonwidth;

Canvas->Brush->Color = clBtnFace;
Canvas->Pen->Style = psClear;
Canvas->Rectangle( bitmap_r.Left, bitmap_r.Top, bitmap_r.Right+1, bitmap_r.Bottom+1 );

MyFrame3DButton( Canvas, bitmap_r.Left, bitmap_r.Top, bitmap_r.Right, bitmap_r.Bottom);

bool minimize_active = (BorderIcons.Contains(biMinimize));
if (minimize_active) Canvas->Pen->Color = cl3DDkShadow;
else Canvas->Pen->Color = clBtnShadow;
Canvas->Pen->Width = 1;
Canvas->Pen->Style = psSolid;

// top-left to top-right
Canvas->MoveTo( bitmap_r.Left + 5, bitmap_r.Top + 10 );
Canvas->LineTo( bitmap_r.Left + 11, bitmap_r.Top + 10 );
Canvas->MoveTo( bitmap_r.Left + 5, bitmap_r.Top + 11 );
Canvas->LineTo( bitmap_r.Left + 11, bitmap_r.Top + 11 );

if (!minimize_active)
	{
    Canvas->Pen->Color = clBtnHighlight;
    Canvas->MoveTo( bitmap_r.Left + 6, bitmap_r.Top + 12 );
    Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 12 );
    Canvas->MoveTo( bitmap_r.Left + 13, bitmap_r.Top + 9 );
    Canvas->MoveTo( bitmap_r.Left + 13, bitmap_r.Top + 12 );
    }

// finished drawing, always release anything that may have been allocated by the Canvas
Canvas->Handle = NULL;

DirectDraw->Log(LOG_OUT,"<<FORM>>::PaintFrame()","");
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::ExitButtonClick(TObject *Sender)
{
if (Enabled) Close();
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::ResetCountersClick(TObject *Sender)
{
fFramesFlipped = 0; fSeconds = 0; fAnimationTicks = 0;
Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::EnableDirectXButtonClick(TObject *Sender)
{
if (DirectDraw != NULL)
	{
    DirectDraw->Enabled = true;//!DirectDraw->Enabled;
    }
Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::UpdateDirectXMessages()
{
if (DirectDraw != NULL)
	{
    if (DirectDraw->Enabled)
		if (DirectDraw->ErrorStrings)
			{
			DebugMessages->Items->Clear();
			for (int i=0;i<DirectDraw->ErrorStrings->Count;i++)
				DebugMessages->Items->Add(DirectDraw->ErrorStrings->Strings[i]);
            DebugMessages->Repaint();
		    }
    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::FormDeactivate(TObject *Sender)
{
DebugMessages->Items->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::FormPaint(TObject *Sender)
{
// --------- debugging display ----------
//Canvas->Pen->Color = clRed;
//Canvas->Font->Color = clRed;
//Canvas->TextOut(200,0,"PAGE # " + IntToStr(fPageNumber));

// --------- normal FormPaint() drawing code using the VCL or GDI with Canvas->Handle as the DC

// display the number of frames, etc. being drawn
TDateTime current_time = Time();
unsigned short chour,cmin,csec,cmsec;
unsigned short lhour,lmin,lsec,lmsec;
current_time.DecodeTime(&chour,&cmin,&csec,&cmsec);
flast_time.DecodeTime(&lhour,&lmin,&lsec,&lmsec);
int seconds_elapsed = 0;
if (csec != lsec)
	{
    if (csec < lsec) seconds_elapsed += 60;
    seconds_elapsed += (csec - lsec);
    }
fSeconds += seconds_elapsed;
flast_time = current_time;

++fPageNumber %= 2;	// 0..1 only

TicksLabel->Caption = "Ticks: " + IntToStr(fAnimationTicks);
FramesLabel->Caption = "Frames: " + IntToStr(fFramesFlipped);
SecondsLabel->Caption = "Seconds: " + IntToStr(fSeconds);
if (fSeconds != 0)
	{
    FramesPerSecondLabel->Caption = "FPS: " + FloatToStrF((float)fFramesFlipped / (float)fSeconds, ffFixed, 6, 2);
	}
AnimSpeedLabel->Caption = "Anim: " + IntToStr(AnimationTimer->Interval);

for (int z=0; z<1000; z++)
   	Canvas->Pixels[random(Width)][random(Height)] = (TColor) ((z << 16) + (z << 8) + z);

// also display some DirectX stats, etc.
if (DirectDraw != NULL)
	{
    DirectXInstalledLabel->Font->Color = clGreen;
    DirectXInstalledLabel->Caption = "DirectX is Installed";

	if (DirectDraw->Enabled)
		{
	    DirectXEnabledLabel->Font->Color = clGreen;
	    DirectXEnabledLabel->Caption = "DirectX drawing is enabled";
	    }
	else
		{
	    DirectXEnabledLabel->Font->Color = clRed;
	    DirectXEnabledLabel->Caption = "DirectX drawing is not enabled.";
	    }
	if (DirectDraw->Debugging)
		{
	    DirectXDebuggingLabel->Font->Color = clGreen;
	    DirectXDebuggingLabel->Caption = "DirectX debugging is enabled";
	    }
	else
		{
	    DirectXDebuggingLabel->Font->Color = clRed;
	    DirectXDebuggingLabel->Caption = "DirectX debugging is not enabled";
	    }
    }
else
	{
    DirectXInstalledLabel->Font->Color = clRed;
    DirectXInstalledLabel->Caption = "DirectX is Not Installed";
    }

// display a box moving about the screen (note: x,y,xincr,yincr global & just above function)
Canvas->Pen->Color = (TColor) RGB(255,255,255);
Canvas->Brush->Color = (TColor) RGB((fx*128)%256,(fx*16)%256,(fx*16+16*fColor)%256) ;
Canvas->Brush->Style = bsSolid;
Canvas->Rectangle( fx,fy, fx+400,fy+200 );

int xx = (fx*2>Width/2) ? fx*2 - Width/2 : Width/2 - fx*2;
int yy = (fy>Width/2) ? fy - Height/2: Height/2 - fy;
Image1->Visible = false;
Image1->SetBounds(xx,yy,fx/64+Image1->Width,fy/64+Image1->Height);
Image1->Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::RepaintMessagesButtonClick(TObject *Sender)
{
// make sure the scroll box of directx messages is realtime.....
UpdateDirectXMessages();
if (DebugMessages->Showing && (ActiveControl == DebugMessages))
	{
    DebugMessages->Hide();
    DebugMessages->Show();
    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::ClearMessagesButtonClick(TObject *Sender)
{
if (Enabled && (DirectDraw != NULL))
	{
    DirectDraw->ErrorStrings->Clear();
	Refresh();
    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::ToggleDebuggingButtonClick(TObject *Sender)
{
if (Enabled && (DirectDraw != NULL))
	{
    DirectDraw->Debugging = !DirectDraw->Debugging;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::AnimationTimerTimer(TObject *Sender)
{
fAnimationTicks++;
fColor++;
fx += fxincr;
fy += fyincr;

if (fx<0) fxincr = 1;
if (fy<0) fyincr = 1;
if (fx+400>Width) fxincr = -1;
if (fy+200>Height) fyincr = -1;

Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::BitBtn2Click(TObject *Sender)
{
if (AnimationTimer->Interval>1000) AnimationTimer->Interval -= 1000;
else if (AnimationTimer->Interval>100) AnimationTimer->Interval -= 100;
else if (AnimationTimer->Interval>10) AnimationTimer->Interval -= 10;
else if (AnimationTimer->Interval>1) AnimationTimer->Interval -= 1;
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::BitBtn4Click(TObject *Sender)
{
if (AnimationTimer->Interval<10) AnimationTimer->Interval += 1;
else if (AnimationTimer->Interval<100) AnimationTimer->Interval += 10;
else if (AnimationTimer->Interval<1000) AnimationTimer->Interval += 100;
else if (AnimationTimer->Interval<10000) AnimationTimer->Interval += 1000;
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::Button1Click(TObject *Sender)
{
Repaint();	
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::Button2Click(TObject *Sender)
{
AnimationTimer->Enabled = !AnimationTimer->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::ScrollBar1Scroll(TObject *Sender, TScrollCode ScrollCode, int &ScrollPos)
{
LittleAnimTimer->Interval = ScrollPos * 4;
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::LittleAnimTimerTimer(TObject *Sender)
{
int xx = 0;
int yy = 0;
int xxincr = 1;
int yyincr = 0;
if (DirectDraw != NULL)
	{
	xx += xxincr;
	yy += yyincr;

	if (xx<1) { yyincr = -1; xxincr = 0; xx = 1; }
	else if (xx > Screen->Width - Image2->Picture->Width) { yyincr = 1; xxincr = 0; xx = Screen->Width - Image2->Picture->Width; }
	if (yy<1) { xxincr = 1; yyincr = 0; yy = 1; }
	else if (yy > Screen->Height - Image2->Picture->Height - 1) { xxincr = -1; yyincr = 0; yy = Screen->Height - Image2->Picture->Height - 1; }

    // save whats currently on the backbuffer & underneath the new image
	TImage* under_image = DirectDraw->GetBackBufferImage(xx,yy,Image2->Picture->Width,Image2->Picture->Height);

    // copy what is currently displayed on the screen to the backbuffer
    DirectDraw->FlipGDIRectToBackBuffer(xx,yy,Image2->Picture->Width,Image2->Picture->Height);

    // copy the image over the top
    DirectDraw->BlitToBackBuffer(xx,yy,Image2,cmSrcCopy);	// CopyMode

    // display the updated screen area
    DirectDraw->FlipBackBufferRectToGDI(xx,yy,Image2->Picture->Width,Image2->Picture->Height);

    // restore what was underneath
    if (under_image != NULL)
    	{
        DirectDraw->BlitToBackBuffer(xx,yy,under_image);
	    delete under_image;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::FormCreate(TObject *Sender)
{
/* DirectDraw->Enabled = true;
if (DirectDraw != NULL)
	{
	if (DirectDraw->Enabled)
		{
		if (DirectDraw->SetDisplayMode(640,480,8))
	    	{
			DirectDraw->Log(LOG_NOTE,"",">>>>>>>>>>>>>> Display Mode Set to 640x480x8");
	        }
        }
    }
*/
fFramesFlipped = 0; fSeconds = 0; fAnimationTicks = 0;
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::SpeedButton1Click(TObject *Sender)
{
if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"INSERTION::",Edit1->Text);
}
//---------------------------------------------------------------------------
