//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
//---------------------------------------------------------------------------
#include "TDDForm.h"
#include "winresrc.h"
#include "penwin.h"
//---------------------------------------------------------------------------
#pragma link "TDirectDraw"
#pragma link "Grids"
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
TDDForm *DDForm;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// remember: 	SetPriorityClass(hProcess: THandle; dwPriorityClass: DWORD): BOOL; stdcall;
// remember:	Frame3D(Canvas, Rect, TopColor, BottomColor, BevelWidth);
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TDDForm::TDDForm(TComponent* Owner)
	: TForm(Owner)
{
fLeft = Left;
fTop = Top;
fWidth = Width;
fHeight = Height;

fBorderX = GetSystemMetrics(SM_CXDLGFRAME);
fBorderY = GetSystemMetrics(SM_CYDLGFRAME);
fCaptionHeight = GetSystemMetrics(SM_CYCAPTION);
fButtonWidth = GetSystemMetrics(SM_CXSMICON);
fButtonHeight = GetSystemMetrics(SM_CYSMICON);
fScrollbarWidth = GetSystemMetrics( SM_CXHSCROLL );
fScrollbarHeight = GetSystemMetrics( SM_CYHSCROLL );
fThumbnailHeight = GetSystemMetrics( SM_CXHTHUMB );
fIconWidth = GetSystemMetrics( SM_CXSMICON );
fIconHeight = GetSystemMetrics( SM_CYSMICON );


fAnimationTicks = 0;
fFramesFlipped = 0;
fSeconds = 0;
fColor = 0;

fFormIsActive = false;
fFormIsMoving = false;
fFormIsBeingRestored = false;
fFormIsBeingMinimized = false;
fFormIsBeingMaximized = false;
fMenuIsDisplayed = false;

fHandlingWMPAINT = false;

flast_time = Time();
fx = 0;
fy = 0;
fxincr = 1;
fyincr = 1;

// save the name of the font used to render the caption
NONCLIENTMETRICS ncm;
ncm.cbSize = sizeof(NONCLIENTMETRICS);
SystemParametersInfo( SPI_GETNONCLIENTMETRICS, 0, &ncm, 0 );
fCaptionFontName = ncm.lfMenuFont.lfFaceName;

if (DirectDraw == NULL) DirectDraw = new TDirectDraw(this);
if (DirectDraw != NULL) DirectDraw->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall 	TDDForm::~TDDForm()
{
if (DirectDraw != NULL)
	if (DirectDraw->Owner == this)
		{
	    delete DirectDraw;
	    DirectDraw = NULL;
	    }
}
//---------------------------------------------------------------------------
void __fastcall	TDDForm::ExpandBorder( RECT* r, TBorderStyle borderstyle, bool include_caption )
{
int borderx = 0;
int bordery = 0;
int captionheight = 0;
switch (borderstyle)
	{
    case bsDialog:		borderx = 3;
    					bordery = 3;
                        captionheight = 21;
                        break;
    case bsNone:		borderx = 0;
    					bordery = 0;
                        captionheight = 0;
                        break;
    case bsSingle:		borderx = 3;
                        bordery = 3;
                        captionheight = 21;
                        break;
    case bsSizeable:	borderx = 3;
                        bordery = 3;
                        captionheight = 21;
                        break;
    case bsSizeToolWin:	borderx = 2;
                        bordery = 2;
                        captionheight = 21;
                        break;
    case bsToolWindow:	borderx = 2;
                        bordery = 2;
                        captionheight = 21;
                        break;
	}
r->top -= bordery;
r->left -= borderx;
r->right += borderx;
r->bottom += bordery;

if (include_caption) r->top -= captionheight;
}
//---------------------------------------------------------------------------
void __fastcall	TDDForm::ReduceBorder( RECT* r, TBorderStyle borderstyle, bool include_caption )
{
int borderx = 0;
int bordery = 0;
int captionheight = 0;
switch (borderstyle)
	{
    case bsDialog:		borderx = 3;
    					bordery = 3;
                        captionheight = 21;
                        break;
    case bsNone:		borderx = 0;
    					bordery = 0;
                        captionheight = 0;
                        break;
    case bsSingle:		borderx = 3;
                        bordery = 3;
                        captionheight = 21;
                        break;
    case bsSizeable:	borderx = 3;
                        bordery = 3;
                        captionheight = 21;
                        break;
    case bsSizeToolWin:	borderx = 2;
                        bordery = 2;
                        captionheight = 21;
                        break;
    case bsToolWindow:	borderx = 2;
                        bordery = 2;
                        captionheight = 21;
                        break;
	}
r->top += bordery;
r->left += borderx;
r->right -= borderx;
r->bottom -= bordery;

if (include_caption) r->top += captionheight;
}
//---------------------------------------------------------------------------
void __fastcall	TDDForm::ExcludeOtherForms( HWND Handle, HDC hdc )
{
// start at the z-factor of our current form
//DirectDraw->Log(LOG_NOTE,Name + "::ExcludeOtherForms()","excluding");
HWND hwnd = GetWindow( Handle, GW_HWNDPREV );
int iter = 0;
// scan through all other windows all higher z-factors
while (hwnd != NULL)
	{
    // if it's not the current form (ie. the one being drawn)
    if (hwnd != Handle)
    	{
        // determine the visible state of the relevant form
        TForm* form = NULL;
        for (int j=0;j<Screen->FormCount;j++)
        	if (Screen->Forms[j]->Handle == hwnd)
            	{
                form = Screen->Forms[j];
                j = Screen->FormCount+1;
                }
        bool form_is_visible = false;
        if (form != NULL) form_is_visible = form->Visible;

        // if the form is visible, make sure not to paint over it...
        if (form_is_visible)
        	{
//	        DirectDraw->Log(LOG_NOTE,Name+"::ExcludeOtherForms()","excluding '" + form->Name + "'");
            RECT exclude_r;
            // if the form is minimized, get the sizes of the minimized caption bar
			if (form->WindowState == wsMinimized)
            	{
	            // get the top, left of the minimized bar
	            WINDOWPLACEMENT wndplace;
	            wndplace.length = sizeof(WINDOWPLACEMENT);
	            GetWindowPlacement( form->Handle, &wndplace );

	            exclude_r.left = wndplace.ptMinPosition.x;
	            exclude_r.top  = wndplace.ptMinPosition.y;

            	// get the width, height of the minimized bar
	            MINIMIZEDMETRICS minmetrics;
	            minmetrics.cbSize = sizeof(MINIMIZEDMETRICS);
				SystemParametersInfo( SPI_GETMINIMIZEDMETRICS, sizeof(MINIMIZEDMETRICS), &minmetrics, 0 );

   	            exclude_r.right = exclude_r.left + minmetrics.iWidth + 2*fBorderX;
	            exclude_r.bottom = exclude_r.top + fBorderY + fCaptionHeight + 2;

//				DirectDraw->Log(LOG_NOTE,Name+"::ExcludeOtherForms()","excluding part " + form->Name + " - rect " + IntToStr(exclude_r.left)+","+IntToStr(exclude_r.top)+"-" + IntToStr(exclude_r.right)+","+IntToStr(exclude_r.bottom));
				ExcludeClipRect( hdc, exclude_r.left, exclude_r.top, exclude_r.right, exclude_r.bottom );
                }
            else
            	// exclude the entire form area
            	{
                exclude_r.left = form->Left;
                exclude_r.top = form->Top;
                exclude_r.right = exclude_r.left + form->Width;
                exclude_r.bottom = exclude_r.top + form->Height;
//				DirectDraw->Log(LOG_NOTE,Name+"::ExcludeOtherForms()","excluding entire " + form->Name + " - rect " + IntToStr(exclude_r.left)+","+IntToStr(exclude_r.top)+"-" + IntToStr(exclude_r.right)+","+IntToStr(exclude_r.bottom));
				ExcludeClipRect( hdc, exclude_r.left, exclude_r.top, exclude_r.right, exclude_r.bottom );
            	}
            }
        else
        	{
//            DirectDraw->Log(LOG_NOTE,"::WndProc","form is not visible");
            }
        }
//    else
//    	DirectDraw->Log(LOG_NOTE,"::WndProc","retrieved hwnd is current drawing window");

	// go to the next highest z-order
    hwnd = GetWindow( hwnd, GW_HWNDPREV );
    }
//DirectDraw->Log(LOG_OUT,"::ExcludeOtherForms","" );
}
//---------------------------------------------------------------------------
void	__fastcall	TDDForm::ExcludeMenu( HDC hdc, HMENU hmenu )
{
// skip out if the menu is not currently displayed
if (!fMenuIsDisplayed) return;
if (Screen->ActiveForm != this) return;

//DirectDraw->Log(LOG_IN, "::ExcludeMenu","" );

// if the menu is null, get the default menu for this window
if (hmenu == NULL) hmenu = GetSystemMenu( Handle, false );

// assuming we have a valid menu
if (hmenu != NULL)
	{
//    DirectDraw->Log(LOG_NOTE, "::ExcludeMenu","found a valid HMenu" );
    // determine the number of items in this menu
    int num_items = GetMenuItemCount( hmenu );
    RECT exclude_r;
    MENUITEMINFO item_info;
    item_info.cbSize = sizeof(MENUITEMINFO);

//    DirectDraw->Log(LOG_NOTE, "::ExcludeMenu","menu has " +IntToStr(num_items) + " items");
    // loop through each item in turn, getting the region used by that item & excluding
    // it from the current draw region

    fExcludeMenu.Left = 100000;
    fExcludeMenu.Top = 100000;
    fExcludeMenu.Right = -1;
    fExcludeMenu.Bottom = -1;
    for (int i=0;i<num_items;i++)
    	{
//    DirectDraw->Log(LOG_NOTE, "::ExcludeMenu","getting info for item # " + IntToStr(i));
        if (GetMenuItemRect( Handle, hmenu, i, &exclude_r ) != 0)
        	{
//    DirectDraw->Log(LOG_NOTE, "::ExcludeMenu","retrieved & excluding menu item rect: " + IntToStr(exclude_r.left) + "," + IntToStr(exclude_r.top) + " - " + IntToStr(exclude_r.right) + "," + IntToStr(exclude_r.bottom));
            exclude_r.right += fBorderX*2;
            exclude_r.bottom += fBorderY*2;

//    DirectDraw->Log(LOG_NOTE, "::ExcludeMenu","excluding menu item rect (modified): " + IntToStr(exclude_r.left) + "," + IntToStr(exclude_r.top) + " - " + IntToStr(exclude_r.right) + "," + IntToStr(exclude_r.bottom));
			ExcludeClipRect( hdc, exclude_r.left, exclude_r.top, exclude_r.right, exclude_r.bottom );

            // because the menu item is displayed on the GDI surface,
            // and we cannot force it to draw onto our backbuffer DC,
            // make sure to copy the menu item from the gdi surface to the backbuffer
            // before the blit() occurs

            if (exclude_r.left < fExcludeMenu.Left) 		fExcludeMenu.Left = exclude_r.left;
            if (exclude_r.top < fExcludeMenu.Top) 			fExcludeMenu.Top = exclude_r.top;
            if (exclude_r.right > fExcludeMenu.Right) 		fExcludeMenu.Right = exclude_r.right;
            if (exclude_r.bottom > fExcludeMenu.Bottom) 	fExcludeMenu.Bottom = exclude_r.bottom;
/*            HDC screendc =  CreateDC("DISPLAY",NULL,NULL,NULL);
            BitBlt( hdc, exclude_r.left, exclude_r.top,
            			exclude_r.right - exclude_r.left,
                        exclude_r.bottom - exclude_r.top,
            		screendc, exclude_r.left, exclude_r.top, SRCCOPY );
			DeleteDC( screendc );
*/
//            DirectDraw->FlipGDIRectToBackBuffer(exclude_r.left,exclude_r.top,exclude_r.right-exclude_r.left,exclude_r.bottom-exclude_r.top,true);

	        // if there are any sub menus attached to this item
            GetMenuItemInfo( hmenu, i, TRUE, &item_info );
            if (((item_info.fMask & MIIM_SUBMENU) != 0) && (item_info.hSubMenu != NULL))
            	// make sure to exclude the sub-menu's as well
                {
//    DirectDraw->Log(LOG_NOTE, "::ExcludeMenu","item has sub-menu, excluding it also");
                ExcludeMenu( hdc, item_info.hSubMenu );
                }
            }
        }
    }
//DirectDraw->Log(LOG_OUT, "::ExcludeMenu","" );
}
//---------------------------------------------------------------------------
void 	__fastcall TDDForm::WndProc(Messages::TMessage &Message)
{
if (DirectDraw != NULL)
	{
    if (!DirectDraw->Enabled)
    	{
        TForm::WndProc(Message);
        return;
        }
    }
else
	{
    TForm::WndProc(Message);
    return;
    }

// handle any repaint messages coming from Windows rather than letting the default
// WndProc function handle them as the default WndProc function automatically draws
// the form when receiving WM_PAINT, WM_NCPAINT, WM_NCACTIVATE.....
// since the form redrawing code uses a windows gdi Paint3d function which blits to
// the display on completion (we have no control over this), it is probably better
// to use our own handler so that we can control exactly when to blit what.

int		message = Message.Msg;
int		lparam	= Message.LParam;
int		wparam	= Message.WParam;
int		sysmsg  = 0;
bool 	exclude_other_forms = false;

// pre-VCL message handling
switch (message)
	{
	case WM_ERASEBKGND:
    	Message.Msg = 0;
        Message.Result = 0;
        return;

    case WM_ACTIVATE:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,Name + "::WndProc()","WM_ACTIVATE");

		// if we're possibly using DirectDraw stuff & we're not already handling a paint message
    	if ((DirectDraw != NULL) && !fHandlingWMPAINT)
        	{
        	if (!DirectDraw->Enabled) DirectDraw->Enabled = true;
            if (DirectDraw->Enabled)
            	{
    	        // make sure the GDI is the primary surface
	            DirectDraw->FlipToGDI();

				// copy what's currently displayed to our back buffer
	//			DirectDraw->Log(LOG_BEFORE,"<<FORM>>::WndProc()","DirectDraw->FlipGDIRectToBackBuffer()");
	//            DirectDraw->FlipGDIRectToBackBuffer(fLeft,fTop,fWidth,fHeight);
	//			DirectDraw->Log(LOG_AFTER,"<<FORM>>::WndProc()","DirectDraw->FlipGDIRectToBackBuffer()");

	            int active_flag = LOWORD(wparam);
	            fFormIsActive = ((active_flag == WA_ACTIVE) || (active_flag == WA_CLICKACTIVE));

                if (fFormIsActive) Perform( WM_PAINT, 0, 0 );
	 	        }
    		}
		// let the VCL handle the message as normal
        return;

    case WM_NCPAINT:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,Name + "::WndProc()","WM_NCPAINT nonclient");
        break;

    case WM_PAINT:

    	// simply log all WM_PAINT messages for posterity
//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,Name + "::WndProc()","WM_PAINT");

		// if we're possibly using DirectDraw stuff & we're not already handling a paint message
    	if ((DirectDraw != NULL) && !fHandlingWMPAINT)
        	// and DirectDraw stuff is enabled
            if (DirectDraw->Enabled)
            	// note: TForm::WndProc generates a WM_PAINT during it's handling of
                // minimize, maximize & restore messages. Problem is that the WM_PAINT is
                // generated before TForm::WindowState is updated, causing us problems when
                // the painting reacts to the WindowState. thus we set flags just before
                // these events occur & ignore the WM_PAINT message at this point.
            	if (!fFormIsBeingMinimized && !fFormIsBeingMaximized && !fFormIsBeingRestored)
		            {
			    	// no point doing ANYTHING if there is another window that is maximized
			        for (int form=0;form<Screen->FormCount;form++)
                        if ((Screen->Forms[form] != this) &&
                        	(Screen->Forms[form]->Visible) &&
                        	(Screen->Forms[form]->WindowState == wsMaximized) &&
                            (Screen->ActiveForm != this)) //? dunno why ?
                            {
                            Message.Result = 0;
							return;
                            }

 	                // set a flag so that we don't handle multiple WM_PAINT messages while
	                // we're still handling the first WM_PAINT message (this can happen)
		            fHandlingWMPAINT = true;

					//
	                //	paint the entire form (ie. including caption) to the back buffer DC
	                //

			        // get a back buffer DC from DirectDraw if possible, returns NULL if not
	                HDC hdc = DirectDraw->GetBackBufferDC();

	    			// if the DC retrieved is valid
			        if (hdc != NULL)
			    	   	{
//                        exclude_other_forms = (Screen->ActiveForm != this);
                        
/*                         switch (BorderStyle)
                        	{
                            case bsDialog:		fBorderX = 3;
                            					fBorderY = 3;
                                                fCaptionHeight = 21;
                                				break;
                            case bsNone:		fBorderX = 0;
                                				fBorderY = 0;
                                                fCaptionHeight = 0;
                                                break;
                            case bsSingle:		fBorderX = 3;
                                				fBorderY = 3;
                                                fCaptionHeight = 21;
                                                break;
                            case bsSizeable:	fBorderX = 3;
                                				fBorderY = 3;
                                                fCaptionHeight = 21;
                                                break;
                            case bsSizeToolWin:	fBorderX = 2;
                                				fBorderY = 2;
                                                fCaptionHeight = 21;
                                                break;
                            case bsToolWindow:	fBorderX = 2;
                                				fBorderY = 2;
                                                fCaptionHeight = 21;
                            					break;
		                    }
*/
						// determine the bounds of the frame that we have to paint
						RECT form_r;

	                    // when the window is minimized, retrieve relevant sizes,
                        // and overwrite our internal location & size variables that are
                        // setup each time we get a WM_SIZE or WM_MOVE message.
						if (WindowState == wsMinimized)
	                    	{
	                        // get the top, left of the minimized bar
	                        WINDOWPLACEMENT wndplace;
	                        wndplace.length = sizeof(WINDOWPLACEMENT);
	                        GetWindowPlacement( Handle, &wndplace );

	                        form_r.left = wndplace.ptMinPosition.x;
	                        form_r.top = wndplace.ptMinPosition.y;

	                        // get the width, height of the minimized bar
	                        MINIMIZEDMETRICS minmetrics;
	                        minmetrics.cbSize = sizeof(MINIMIZEDMETRICS);
							SystemParametersInfo( SPI_GETMINIMIZEDMETRICS, sizeof(MINIMIZEDMETRICS), &minmetrics, 0 );

	                        form_r.right = form_r.left + minmetrics.iWidth + 2*fBorderX;
	                        form_r.bottom = form_r.top + fBorderY + fCaptionHeight + 2;

//                            DirectDraw->Log(LOG_NOTE,"::WndProc","minimized width,height == " + IntToStr(form_r.right-form_r.left) + "," + IntToStr(form_r.bottom-form_r.top));
	                        }
						else
                        	{
		                    form_r.left = fLeft;
							form_r.top  = fTop;
			                form_r.right = form_r.left+fWidth;
		                   	form_r.bottom = form_r.top+fHeight;
                            }

			            // tell windows that the region of the whole form (ie. including frame)
	                    // is to be repainted (note: this sets the clip region to the whole form)
			            InvalidateRect(Handle,&form_r,false);

	                    // adjust the clip rect so that all drawing is clipped to the form area
//				    	DirectDraw->Log(LOG_NOTE,Name + "::WndProc()","painting frame");
	                    HRGN form_hrgn = CreateRectRgn( form_r.left, form_r.top, form_r.right, form_r.bottom );
	                    int result = SelectClipRgn( hdc, form_hrgn );
	                    DeleteObject( form_hrgn );

						// make sure not to paint over any other forms
						if (WindowState != wsMinimized) ExcludeOtherForms( Handle, hdc );

	                    // paint the frame
	                    PaintFrame(hdc,form_r);

   	                    // only paint internals when the form is not minimized
	                    if ((WindowState != wsMinimized) && (message != WM_NCPAINT))
	                    	{
//					    	DirectDraw->Log(LOG_NOTE,Name + "::WndProc()","painting client");
	    	                // determine the client area just inside the frame
		                    RECT client_r = form_r;
	                        client_r.left += fBorderX;
	    					client_r.top += fBorderY + fCaptionHeight;
	                        client_r.right -= fBorderX;
	                        client_r.bottom -= fBorderY;

		                    // adjust the clip rect so that all drawing is clipped to the client area
		                    HRGN client_hrgn = CreateRectRgn( client_r.left, client_r.top, client_r.right, client_r.bottom );
		                    int result = SelectClipRgn( hdc, client_hrgn );
		                    DeleteObject( client_hrgn );

							// make sure not to paint over any other forms
                           	ExcludeOtherForms( Handle, hdc );

    	                    // make sure that we don't paint over any menus
//	                        ExcludeMenu( hdc, NULL );

		                    // move the draw start location to the top,left of the form's client area
                            int dy = client_r.top;
//                            if (Menu != NULL) dy += fCaptionHeight - 2;
						    MoveWindowOrg( hdc, client_r.left, dy );

                            // clear underneath the area we need to repaint
		                    try
		                    	{
		                        Canvas->Handle = hdc;
								Canvas->Brush->Color = Color;
								Canvas->Brush->Style = bsSolid;
								Canvas->FillRect( ClientRect );
		                        }
		                    catch ( ... ) {}
							Canvas->Handle = NULL;

			                // paint the contents of the form, including all controls, etc.
//		        			DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","painting window, controls, etc.");
			                Messages::TWMPaint	MyPaintMessage;
			                MyPaintMessage.Msg = WM_PAINT;
			                MyPaintMessage.DC  = hdc;
			                MyPaintMessage.Unused = 0;
			                MyPaintMessage.Result = 0;
			                PaintHandler(MyPaintMessage);

		                    // reset the DC's window paint origin
						    MoveWindowOrg( hdc, -client_r.left, -dy );
		                    }

						// figure out the region we are to blit
                        RECT blit_r = form_r;
                        if (message == WM_NCPAINT) GetClipBox( Handle, &blit_r );

					    // release the DirectX supplied DC
						DirectDraw->ReleaseBackBufferDC();
		                hdc = NULL;

                        // flip (blit) the menu stuff from the display screen to the backbuffer ???
//                        if (fMenuIsDisplayed)
//                            DirectDraw->FlipGDIRectToBackBuffer( fExcludeMenu.Left, fExcludeMenu.Top, fExcludeMenu.Right - fExcludeMenu.Left, fExcludeMenu.Bottom - fExcludeMenu.Top );

	                    // flip (blit) the stuff from the backbuffer to the display
						fFramesFlipped++;
		                DirectDraw->FlipBackBufferRectToGDI(blit_r.left,blit_r.top,blit_r.right-blit_r.left,blit_r.bottom-blit_r.top);

			            // tell windows that the entire form area (screen?) has been repainted
   			            ValidateRect(Handle,NULL);
			            }

	                // reset the flag used to stop multiple WM_PAINT messages while
	                // we're still handling the first WM_PAINT message (this can happen)
			        fHandlingWMPAINT = false;

			        // clear the Message so that the VCL does nothing else
			        Message.Msg = 0;
		            }
    			else
                	{
                    // simply clear relevant flags
                    if (fFormIsBeingRestored) 	fFormIsBeingRestored = false;
	            	if (fFormIsBeingMinimized) 	fFormIsBeingMinimized = false;
                    if (fFormIsBeingMaximized) 	fFormIsBeingMaximized = false;
                    // tell windows that the window has been redrawn (even though it hasn't)
                    ValidateRect( Handle, NULL );
                    }
		// let the VCL handle the message as normal
        return;

	case WM_DRAWITEM:

		// only modify behaviour when using DirectDraw stuff, otherwise drop through to
        // the VCL default WndProc()
//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_DRAWITEM, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
//		lpdraw = (LPDRAWITEMSTRUCT) Message.LParam;
//		if (lpdraw->CtlType == ODT_LISTBOX) return;
		break;

   	// don't log any messages for WM_MEASUREITEM messages
    case WM_MEASUREITEM:

//       	DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()>>>>>>>>>>>","Received WM_MEASUREITEM, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

    // simply log the various messages for debugging purposes
    case WM_VSCROLL:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_VSCROLL, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

    case WM_HSCROLL:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_HSCROLL, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
    	break;

	case WM_NCCALCSIZE:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_NCCALCSIZE, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_COMMAND:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_COMMAND, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_GETTEXT:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_GETTEXT, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_GETTEXTLENGTH:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_GETTEXTLENGTH, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLORMSGBOX:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLORMSGBOX, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLOREDIT:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLOREDIT, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLORLISTBOX:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLORLISTBOX, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLORBTN:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLORBTN, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLORDLG:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLORDLG, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLORSCROLLBAR:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLORSCROLLBAR, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_CTLCOLORSTATIC:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLORSTATIC, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_NCHITTEST:
                             
//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_NCHITTEST, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case CM_CURSORCHANGED:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_CURSORCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case CM_FONTCHANGED:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_FONTCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case CN_DRAWITEM:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_DRAWITEM, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_SETCURSOR:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_SETCURSOR, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_MOUSEFIRST:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_MOUSEFIRST, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_NCMOUSEMOVE:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_NCMOUSEMOVE, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_CAPTURECHANGED:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CAPTURECHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_MENUSELECT:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_MENUSELECT, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));

		{
        UINT uItem = (UINT) LOWORD(wparam);   // menu item or submenu index
		UINT fuFlags = (UINT) HIWORD(wparam); // menu flags
		HMENU hmenu = (HMENU) lparam;          // handle of menu clicked
// if the fuFlags parameter contains 0xFFFF and the hmenu parameter contains NULL, Windows has closed the menu.
		if ((fuFlags == 0xFFFF) && (hmenu == NULL))
        	{
            fMenuIsDisplayed = false;
//			if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","menu is not displayed");
            }
        else
        	{
        	fMenuIsDisplayed = true;
//			if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","menu IS displayed");
            }
        }
		break;

	case WM_SYSCOMMAND:

        // determine if the form is about to be resized using the minimize, maximize, restore
        // system commands.
        // the reason for doing this is that when the vcl / windows handles this message, it
        // generates a WM_PAINT message before updating TForm::WindowState.
        // ie. we don't know how to paint the form otherwise.
        sysmsg = (wparam & 0x0000FFF0);
        if (Application->MainForm != this)
        	{
            fFormIsBeingRestored  = (sysmsg == SC_RESTORE);
	        fFormIsBeingMinimized = (sysmsg == SC_MINIMIZE);
	        fFormIsBeingMaximized = (sysmsg == SC_MAXIMIZE);
	        }
		break;

	case WM_NCLBUTTONDOWN:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_NCLBUTTONDOWN, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_GETMINMAXINFO:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_GETMINMAXINFO, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_MOVE:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_MOVE, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_SIZE:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_SIZE, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_WINDOWPOSCHANGING:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_WINDOWPOSCHANGING, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
        break;

	case WM_WINDOWPOSCHANGED:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_WINDOWPOSCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLORBTN:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLORBTN, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLORDLG:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLORDLG, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLOREDIT:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLOREDIT, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLORLISTBOX:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLORLISTBOX, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLORMSGBOX:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLORMSGBOX, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLORSCROLLBAR:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLORSCROLLBAR, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_CTLCOLORSTATIC:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_CTLCOLORSTATIC, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_DIALOGKEY:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_DIALOGKEY, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_DIALOGCHAR:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_DIALOGCHAR, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_CHILDKEY:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_CHILDKEY, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_SYSKEYUP:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_SYSKEYUP, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_SYSKEYDOWN:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_SYSKEYDOWN, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_PARENTNOTIFY:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_PARENTNOTIFY, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_MOUSEACTIVATE:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_MOUSEACTIVATE, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_FOCUSCHANGED:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_FOCUSCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_CTLCOLORMSGBOX-1:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_CTLCOLOR??????, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_PARENTSHOWHINTCHANGED:

//    	if (DirectDraw != NULL) DirectDraw->Log/(LOG_NOTE,"<<FORM>>::WndProc()","received CM_PARENTSHOWHINTCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_SETFOCUS:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_SETFOCUS, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_KILLFOCUS:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_KILLFOCUS, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_ICONCHANGED:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_ICONCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case WM_KEYUP:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received WM_KEYUP, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_SYSKEYDOWN:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_SYSKEYDOWN, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_NOTIFY:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_NOTIFY, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_SYSCHAR:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_SYSCHAR, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CN_KEYDOWN:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CN_KEYDOWN, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_ENABLEDCHANGED:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_ENABLEDCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

	case CM_CTL3DCHANGED:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","received CM_CTL3DCHANGED, WParam=" + IntToStr(Message.WParam) + ", LParam="+IntToStr(Message.LParam));
		break;

    default:

//    	if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"<<FORM>>::WndProc()","unknown message " + IntToStr(message));
        break;
    }

// let the VCL handle the message
TForm::WndProc(Message);

// post-VCL message handling
switch (message)
	{
	case WM_NCACTIVATE:
		fFormIsActive = Active;
        break;

	case WM_NCPAINT:
/*         {
        for (int form=0;form<Screen->FormCount;form++)
        	{
            if ((Screen->Forms[form] != this) && Screen->Forms[form]->Visible)
            	Screen->Forms[form]->Perform( WM_PAINT, 0, 0 );
            }
        }
*/
		break;

    case WM_SIZE:
    case WM_MOVE:

        if (DirectDraw != NULL)
        	{
            DirectDraw->Log(LOG_NOTE, "========================================================","");
            DirectDraw->Log(LOG_NOTE, Name + "::WndProc()","WM_MOVE");
            }

        fWidth = Width;
		fHeight = Height;
		fLeft = Left;
		fTop = Top;
    	if (fFormIsActive) Perform( WM_PAINT, 0, 0 );
        break;

    case WM_MOUSEMOVE:

//    	if (DirectDraw != NULL) DirectDraw->DrawMouseCursor();
        break;

    case WM_SETCURSOR:
    case WM_NCMOUSEMOVE:

//    	if (DirectDraw != NULL) DirectDraw->DrawMouseCursor();
        break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::PaintHandler(Messages::TWMPaint &Message)
{
// simply check our preconditions & skip out if not appropriate
if (DirectDraw != NULL)
	{
	if (!DirectDraw->Enabled)
    	{
	    TForm::PaintHandler(Message);
	    return;
	    }
    }
else
	{
	TForm::PaintHandler(Message);
    return;
    }

//DirectDraw->Log(LOG_IN,"<<FORM>>::PaintHandler()","");

// if the supplied DC is okay
HDC hdc = Message.DC;
// use standard function calls to paint to our DirectX surface
try
  	{
    int	SaveIndex;
    int Clip;

    if (ControlCount==0)
    	{
//		DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintHandler()","no controls, simply painting window");
        PaintWindow(hdc);
        }
    else
    	{
//		DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintHandler()","has controls, calculating clip extent");
        SaveIndex = SaveDC( hdc );
	    Clip = SIMPLEREGION;
        for (int i=0;i<ControlCount;i++)
			{
            bool control_is_visible = Controls[i]->Visible;
		    bool control_design_visible = !Controls[i]->ControlStyle.Contains(csNoDesignVisible);

		   	if (control_is_visible && control_design_visible)
				{
	            Clip = ExcludeClipRect( hdc, Controls[i]->Left,
	            							 Controls[i]->Top,
	            							 Controls[i]->Left + Controls[i]->Width,
	                                         Controls[i]->Top + Controls[i]->Height );
	            if (Clip == NULLREGION) break;
	            }
            }
        if (Clip != NULLREGION)
        	{
//			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintHandler()","clip region is not null, painting window");
            PaintWindow( hdc );
            }
//        else
//   			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintHandler()","clip region is null, NOT painting window");

        RestoreDC( hdc, SaveIndex );
        }
//	DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintHandler()","painting controls");
    PaintControls( hdc, NULL );
	}
// unless a problem occurs
catch (...)
	{
//	DirectDraw->Log(LOG_OUT,"<<FORM>>::PaintHandler()","VCL paint on DirectX DC - NOT SUCCESSFUL!");
	}
//DirectDraw->Log(LOG_OUT,"<<FORM>>::PaintHandler()","");
}
//---------------------------------------------------------------------------
void	__fastcall	TDDForm::PaintWindow(HDC hdc)
{
if (hdc == NULL) return;
if ((DirectDraw != NULL) && fHandlingWMPAINT)
	{
	if (!DirectDraw->Enabled)
    	{
	    TForm::PaintWindow(hdc);
	    return;
	    }
    }
else
	{
	TForm::PaintWindow(hdc);
    return;
    }

//DirectDraw->Log(LOG_IN,"<<FORM>>::PaintWindow()","");

Canvas->Handle = NULL;
try
	{
    Canvas->Handle = hdc;
    Paint();
    }
catch ( ... ) {}
// always release anything that might have been allocated in Paint()
Canvas->Handle = NULL;

//DirectDraw->Log(LOG_OUT,"<<FORM>>::PaintWindow()","");
}
//---------------------------------------------------------------------------
void	__fastcall	TDDForm::PaintControls(HDC hdc, TControl* First)
{
// simply check our preconditions & skip out if not appropriate
if (hdc == NULL) return;
if ((DirectDraw != NULL) && fHandlingWMPAINT)
	{
	if (!DirectDraw->Enabled)
    	{
	    TForm::PaintControls(hdc,First);
	    return;
	    }
    }
else
	{
	TForm::PaintControls(hdc,First);
    return;
    }
    
//DirectDraw->Log(LOG_IN,"<<FORM>>::PaintControls()","");
if (ControlCount == 0)
	{
//	DirectDraw->Log(LOG_OUT,"<<FORM>>::PaintControls()","ControlCount is 0");
    return;
    }

// quickly scan the controls until we get to the first control, then fall through with the
// value of the first control in "i" (defaulting at zero if First parameter is NULL)
// ; also determine how many controls are meant to be repainted
int controls_to_paint = ControlCount;
int i = 0;
int j = 0;
if (First != NULL)
	{
    controls_to_paint = 1;
	while (j<ControlCount)
	   	{
		if (Controls[j] == First) i = j;
	    j++;
	    }
    }

int k = 0;
while (k<controls_to_paint)
	{
    // use mapped variables
    TControl* control = Controls[i];
//	DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","painting control '" + control->Name + "'");

    // figure out if the class is based on TWinControl (if so, it may require a border).
    // this is done by traversing the ancestor classes of the control until we find a
    // TWinControl parent, or till we run out of parents
    TClass	theclass = control->ClassType();
    bool 	isWinControl = false;
    bool	isScrollingWinControl = false;
    bool	isListBox = false;
	while	(theclass != NULL)
		{
	    System::AnsiString	class_name = theclass->ClassName();
        if (class_name == "TScrollingWinControl")
        	{
            isScrollingWinControl = true;
            break;
            }
        if (class_name == "TListBox")
        	{
            isListBox = true;
            break;
            }
        if (class_name == "TWinControl")
        	{
            isWinControl = true;
            break;
            }
		theclass = theclass->ClassParent();
		}

    RECT control_r;
    control_r.left = control->Left;
    control_r.top = control->Top;
    control_r.right = control_r.left + control->Width;
    control_r.bottom = control_r.top + control->Height;

	bool control_is_transparent = !control->ControlStyle.Contains(csOpaque);
    bool control_is_framed = control->ControlStyle.Contains(csFramed);
    bool control_is_visible = control->Visible;
    bool control_design_visible = !control->ControlStyle.Contains(csNoDesignVisible);
    bool control_rect_visible = RectVisible( hdc, &control_r );

   	if (control_is_visible && control_design_visible && control_rect_visible)
    	{
	    if (ControlState.Contains(csPaintCopy)) control->ControlState >> csPaintCopy;

//		DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","moving window origin to control origin");
	    MoveWindowOrg( hdc, control->Left, control->Top );
//		DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","telling control to erase background");

		if (isScrollingWinControl)
        	{
//			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","Painting TSCROLLINGWINCONTROL");
            TScrollingWinControl* scrollingwincontrol = (TScrollingWinControl*) control;
            scrollingwincontrol->PaintTo(hdc,0,0);
            TControlScrollBar* scrollbar = scrollingwincontrol->HorzScrollBar;
            if (scrollbar->Visible)
            	{
				// get information re: the vertical scrollbar
				SCROLLINFO	scrollinfo;
				scrollinfo.cbSize = sizeof(SCROLLINFO);
				scrollinfo.fMask = SIF_ALL;
				bool info_retrieved = (GetScrollInfo( scrollingwincontrol->Handle, SB_HORZ, &scrollinfo ) != 0);
				int rowsperpage = scrollinfo.nPage;
				int maxrows = rowsperpage;

				// if the info retrieved was valid and we need to display a scrollbar
				if (info_retrieved)
					{
					// vertical scroll bar
					int scrollbarpos = GetScrollPos( scrollingwincontrol->Handle, SB_HORZ );
					int rowoffset = scrollbar->Position;
				    int width = scrollingwincontrol->Width;
					int height = scrollingwincontrol->Height;
					int top = 2;
					int left = width - fScrollbarWidth - 2;
				    int totalrows = scrollinfo.nMax - scrollinfo.nMin + 1;

//					PaintHScrollBar( hdc, scrollingwincontrol->Handle, left, top, width, height, scrollbarpos, rowoffset, rowsperpage, totalrows );
	                }
                }
            scrollbar = scrollingwincontrol->VertScrollBar;
//            if (scrollbar->Visible)
            	{
                // vertical scroll bar
                int top = 0;
                int left = scrollingwincontrol->Width - fScrollbarWidth;

                try
                	{
					Canvas->Handle = hdc;
					Graphics::TBitmap* bitmap = new Graphics::TBitmap();
				    if (bitmap != NULL)
				    	{
					    bitmap->IgnorePalette = true;
						bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_UPARROW) );
						Canvas->Draw( left, top, bitmap );
					    bitmap->Handle = NULL;
						top = scrollingwincontrol->Height - fScrollbarHeight;
						bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_DNARROW) );
						Canvas->Draw( left, top, bitmap );
					    bitmap->Handle = NULL;
	                    top = 0 + fIconHeight + scrollbar->Position / scrollbar->Range;
	                    Canvas->Pen->Color = clRed;
    	                Canvas->Pen->Width = 1;
	                    Canvas->Brush->Color = clRed;
	                    Canvas->Brush->Style = bsSolid;
	                    Canvas->Rectangle( left, top, left + fIconWidth, top + fIconHeight );
						delete bitmap;
				        }
                    }
                catch ( ... ) {}
                Canvas->Handle = NULL;
                }
            }
        else
        if (isListBox)
        	{
//			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","Painting TSCROLLINGWINCONTROL");
            PaintListBox( hdc, (TListBox*) control );
            }
        else
        // derived from TWinControl
        if (isWinControl)
        	{
//			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","Painting WINCONTROL");
            TWinControl* wincontrol = (TWinControl*) control;
            wincontrol->PaintTo(hdc,0,0);
            }
        else
        	// normal controls
        	{
//		    control->Perform( WM_ERASEBKGND, (long) hdc, 0 );
//			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","telling control to paint");
		    control->Perform( WM_PAINT, (long) hdc, 0 );
//			DirectDraw->Log(LOG_NOTE,"<<FORM>>::PaintControls()","control '" + control->Name + "' was painted");
            }

	    MoveWindowOrg( hdc, -control->Left, -control->Top );
	    if (ControlState.Contains(csPaintCopy)) control->ControlState << csPaintCopy;
        }

	// choose the next control
    ++i %= ControlCount;	// wrap to 0..ControlCount-1
    k++;
    }

// debugging
//DirectDraw->Log(LOG_OUT,"<<FORM>>::PaintControls()","painted " + IntToStr(k) + " controls");
}
//---------------------------------------------------------------------------
void	__fastcall TDDForm::Repaint()
{
if (DirectDraw != NULL)
	{
	if (!DirectDraw->Enabled)
    	{
        TForm::Repaint();
        return;
        }
    }
else
	{
	TForm::Repaint();
    return;
    }

if (Visible)
	{
    InvalidateRect(Handle,NULL,false);
    UpdateWindow(Handle);
    }
}
//---------------------------------------------------------------------------
void __fastcall	TDDForm::MyFrame3DWindow( TCanvas* canvas, int left,int top,int right,int bottom,int penwidth )
{
if (canvas == NULL) return;

// color entire frame with single color
canvas->Pen->Style = psSolid;
canvas->Pen->Width = 1;
canvas->Pen->Color = clBtnFace;
canvas->Brush->Style = bsClear;
for (int i=0;i<penwidth;i++) canvas->Rectangle(left+i, top+i, right-i, bottom-i );

// darken left edge
canvas->Pen->Color = clBtnShadow;
canvas->MoveTo( left, top );
canvas->LineTo( left, bottom );
// darken top edge
canvas->MoveTo( left, top );
canvas->LineTo( right-1, top );

// lighten left edge
canvas->Pen->Color = clBtnHighlight;
canvas->MoveTo( left+1, top+1 );
canvas->LineTo( left+1, bottom-1 );

// lighten top edge
canvas->MoveTo( left+1, top+1 );
canvas->LineTo( right-2, top+1 );

// darken right edge
canvas->Pen->Color = cl3DDkShadow;
canvas->MoveTo( right, top );
canvas->LineTo( right, bottom );
canvas->MoveTo( right-1, top+1 );
canvas->LineTo( right-1, bottom-1 );
canvas->Pen->Color = clBtnShadow;
canvas->MoveTo( right-2, top+2 );
canvas->LineTo( right-2, bottom-2 );
// darken bottom edge
canvas->Pen->Color = cl3DDkShadow;
canvas->MoveTo( left, bottom );
canvas->LineTo( right, bottom );
canvas->MoveTo( left+1, bottom-1 );
canvas->LineTo( right-1, bottom-1 );
canvas->Pen->Color = clBtnShadow;
canvas->MoveTo( left+2, bottom-2 );
canvas->LineTo( right-2, bottom-2 );
}
//---------------------------------------------------------------------------
void __fastcall	TDDForm::MyFrame3DButton( TCanvas* canvas, int left,int top,int right,int bottom)
{
if (canvas == NULL) return;

canvas->Pen->Style = psSolid;
canvas->Pen->Width = 1;

// start at bottom,left corner
canvas->MoveTo(left,bottom);
// draw left edge
canvas->Pen->Color = clBtnHighlight;
canvas->LineTo(left,top);
// draw top edge
canvas->LineTo(right,top);
// draw right edge
canvas->Pen->Color = cl3DDkShadow;
canvas->LineTo(right,bottom);
// draw bottom edge
canvas->LineTo(left-1,bottom);
// extra highlight
left++;
right--;
top++;
bottom--;
// draw right edge
canvas->Pen->Color = clBtnShadow;
canvas->MoveTo(right,top);
canvas->LineTo(right,bottom);
// draw bottom edge
canvas->LineTo(left-1,bottom);
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::MyFrame3DThumbnail( TCanvas* canvas, int left, int top, int right, int bottom)
{
if (canvas == NULL) return;

canvas->Pen->Style = psSolid;
canvas->Pen->Width = 1;

// fill rect
canvas->Pen->Style = psClear;
canvas->Brush->Style = bsSolid;
canvas->Brush->Color = clBtnFace;
canvas->Rectangle( left, top, right, bottom );

// start at bottom,left corner
canvas->Pen->Style = psSolid;
canvas->MoveTo(left,bottom);
// draw left edge
canvas->Pen->Color = clBtnFace;
canvas->LineTo(left,top);
// draw top edge
canvas->LineTo(right,top);
// draw right edge
canvas->Pen->Color = cl3DDkShadow;
canvas->LineTo(right,bottom);
// draw bottom edge
canvas->LineTo(left-1,bottom);
// extra highlight
left++;
right--;
top++;
bottom--;
// draw left edge
canvas->Pen->Color = clBtnHighlight;
canvas->MoveTo(left, bottom);
canvas->LineTo(left, top);
// draw top edge
canvas->LineTo(right, top);
// draw right edge
canvas->Pen->Color = clBtnShadow;
canvas->MoveTo(right,top);
canvas->LineTo(right,bottom);
// draw bottom edge
canvas->LineTo(left-1,bottom);
}
//---------------------------------------------------------------------------
void	__fastcall	TDDForm::PaintCommandButton(HDC hdc, int x, int y)
{
// draw the "command" button on the top,left of the caption area
Graphics::TIcon* icon = new Graphics::TIcon();
if (icon != NULL)
	{
    int result = GetClassLong( Application->Handle, GCL_HICONSM );
    if (result != 0)
    	{
        if (!icon->Empty) icon->ReleaseHandle();
	    icon->Handle = (HICON) result;
    	Canvas->CopyMode = cmSrcCopy;
	    Canvas->Draw( x, y, icon );
        }
    delete icon;
    }

/*

TRect bitmap_r;
bitmap_r.Left = x;
bitmap_r.Right = x + fButtonWidth - 1;
bitmap_r.Top = y;
bitmap_r.Bottom = y + fButtonHeight - 1;
Graphics::TBitmap* bitmap = new Graphics::TBitmap();
if (bitmap != NULL)
	{
    bitmap->IgnorePalette = false;
    bitmap->Width = Application->Icon->Width;
    bitmap->Height = Application->Icon->Height;
	bitmap->Canvas->Draw( 0, 0, Application->Icon );

	Canvas->Draw( bitmap_r, bitmap );
	delete bitmap;
    }
*/
}
//---------------------------------------------------------------------------
void	__fastcall	TDDForm::PaintMinimizeButton(HDC hdc, int x, int y)
{
TRect bitmap_r;
bitmap_r.Left = x;
bitmap_r.Right = x + fButtonWidth - 1;
bitmap_r.Top = y;
bitmap_r.Bottom = y + fButtonHeight - 3;

Canvas->Brush->Color = clBtnFace;
Canvas->Pen->Style = psClear;
Canvas->Rectangle( bitmap_r.Left, bitmap_r.Top, bitmap_r.Right+1, bitmap_r.Bottom+1 );

MyFrame3DButton( Canvas, bitmap_r.Left, bitmap_r.Top, bitmap_r.Right, bitmap_r.Bottom);

bool minimize_active = (BorderIcons.Contains(biMinimize));
if (minimize_active) Canvas->Pen->Color = cl3DDkShadow;
else Canvas->Pen->Color = clBtnShadow;
Canvas->Pen->Width = 1;
Canvas->Pen->Style = psSolid;

// top-left to top-right
Canvas->MoveTo( bitmap_r.Left + 5, bitmap_r.Top + 10 );
Canvas->LineTo( bitmap_r.Left + 11, bitmap_r.Top + 10 );
Canvas->MoveTo( bitmap_r.Left + 5, bitmap_r.Top + 11 );
Canvas->LineTo( bitmap_r.Left + 11, bitmap_r.Top + 11 );

if (!minimize_active)
	{
    Canvas->Pen->Color = clBtnHighlight;
    Canvas->MoveTo( bitmap_r.Left + 6, bitmap_r.Top + 12 );
    Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 12 );
    Canvas->MoveTo( bitmap_r.Left + 13, bitmap_r.Top + 9 );
    Canvas->MoveTo( bitmap_r.Left + 13, bitmap_r.Top + 12 );
    }

}
//---------------------------------------------------------------------------
void	__fastcall	TDDForm::PaintMaximizeButton(HDC hdc, int x, int y)
{
TRect bitmap_r;
bitmap_r.Left = x;
bitmap_r.Right = x + fButtonWidth - 1;
bitmap_r.Top = y;
bitmap_r.Bottom = y + fButtonHeight - 3;

Canvas->Brush->Color = clBtnFace;
Canvas->Pen->Style = psClear;
Canvas->Rectangle( bitmap_r.Left, bitmap_r.Top, bitmap_r.Right+1, bitmap_r.Bottom+1 );

MyFrame3DButton( Canvas, bitmap_r.Left, bitmap_r.Top, bitmap_r.Right, bitmap_r.Bottom);

bool maximize_active = (BorderIcons.Contains(biMaximize));
if (maximize_active) Canvas->Pen->Color = cl3DDkShadow;
else Canvas->Pen->Color = clBtnShadow;

Canvas->Pen->Width = 1;
Canvas->Pen->Style = psSolid;

// top-left to top-right
Canvas->MoveTo( bitmap_r.Left + 3, bitmap_r.Top + 3 );
Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 3 );
Canvas->MoveTo( bitmap_r.Left + 3, bitmap_r.Top + 4 );
Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 4 );
// left
Canvas->MoveTo( bitmap_r.Left + 3, bitmap_r.Top + 5 );
Canvas->LineTo( bitmap_r.Left + 3, bitmap_r.Top + 11 );
// right
Canvas->MoveTo( bitmap_r.Left + 12, bitmap_r.Top + 5 );
Canvas->LineTo( bitmap_r.Left + 12, bitmap_r.Top + 11 );
// bottom
Canvas->MoveTo( bitmap_r.Left + 3, bitmap_r.Top + 11 );
Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 11 );

// add highlights to icon when it's not available
if (!maximize_active)
  	{
	Canvas->Pen->Color = clBtnHighlight;
    // top
    Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 5 );
    Canvas->LineTo( bitmap_r.Left + 12, bitmap_r.Top + 5 );
    // left
    Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 5 );
    Canvas->LineTo( bitmap_r.Left + 4, bitmap_r.Top + 11 );
    // right
    Canvas->MoveTo( bitmap_r.Left + 13, bitmap_r.Top + 4 );
    Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 12 );
    // bottom
    Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 12 );
    Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 12 );
    }
}
//---------------------------------------------------------------------------
void	__fastcall	TDDForm::PaintRestoreButton(HDC hdc, int x, int y)
{
TRect bitmap_r;
bitmap_r.Left = x;
bitmap_r.Right = x + fButtonWidth - 1;
bitmap_r.Top = y;
bitmap_r.Bottom = y + fButtonHeight - 3;

Canvas->Brush->Color = clBtnFace;
Canvas->Pen->Style = psClear;
Canvas->Rectangle( bitmap_r.Left, bitmap_r.Top, bitmap_r.Right+1, bitmap_r.Bottom+1 );

MyFrame3DButton( Canvas, bitmap_r.Left, bitmap_r.Top, bitmap_r.Right, bitmap_r.Bottom);

bool restore_active = (BorderIcons.Contains(biMaximize));
if (restore_active) Canvas->Pen->Color = cl3DDkShadow;
else Canvas->Pen->Color = clBtnShadow;
Canvas->Pen->Width = 1;
Canvas->Pen->Style = psSolid;

// top-middle to top-right
Canvas->MoveTo( bitmap_r.Left + 6, bitmap_r.Top + 3 );
Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 3 );
Canvas->MoveTo( bitmap_r.Left + 6, bitmap_r.Top + 4 );
Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 4 );
// middle-left to middle-middle
Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 6 );
Canvas->LineTo( bitmap_r.Left + 11, bitmap_r.Top + 6 );
Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 7 );
Canvas->LineTo( bitmap_r.Left + 11, bitmap_r.Top + 7 );
// bottom-left box
Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 8 );
Canvas->LineTo( bitmap_r.Left + 4, bitmap_r.Top + 11 );
Canvas->MoveTo( bitmap_r.Left + 4, bitmap_r.Top + 11 );
Canvas->LineTo( bitmap_r.Left + 10, bitmap_r.Top + 11 );
Canvas->MoveTo( bitmap_r.Left + 10, bitmap_r.Top + 8 );
Canvas->LineTo( bitmap_r.Left + 10, bitmap_r.Top + 12 );
// top-right box
Canvas->MoveTo( bitmap_r.Left + 6, bitmap_r.Top + 5 );
Canvas->LineTo( bitmap_r.Left + 6, bitmap_r.Top + 7 );
Canvas->MoveTo( bitmap_r.Left + 12, bitmap_r.Top + 5 );
Canvas->LineTo( bitmap_r.Left + 12, bitmap_r.Top + 9 );
Canvas->MoveTo( bitmap_r.Left + 10, bitmap_r.Top + 8 );
Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 8 );
}
//---------------------------------------------------------------------------
void	__fastcall	TDDForm::PaintCloseButton(HDC hdc, int x, int y)
{
TRect bitmap_r;
bitmap_r.Left = x;
bitmap_r.Right = bitmap_r.Left + fButtonWidth - 1;
bitmap_r.Top = y;
bitmap_r.Bottom = bitmap_r.Top + fButtonHeight - 3;

Canvas->Brush->Color = clBtnFace;
Canvas->Pen->Style = psClear;
Canvas->Rectangle( bitmap_r.Left, bitmap_r.Top, bitmap_r.Right+1, bitmap_r.Bottom+1 );

MyFrame3DButton( Canvas, bitmap_r.Left, bitmap_r.Top, bitmap_r.Right, bitmap_r.Bottom);

Canvas->Pen->Color = cl3DDkShadow;
Canvas->Pen->Width = 1;
Canvas->Pen->Style = psSolid;

// top-left to bottom-right
// centre
Canvas->MoveTo( bitmap_r.Left + 5, bitmap_r.Top + 4 );
Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 12 );
// left of centre
Canvas->MoveTo( bitmap_r.Left + 5, bitmap_r.Top + 5 );
Canvas->LineTo( bitmap_r.Left + 12, bitmap_r.Top + 12 );
// right of centre
Canvas->MoveTo( bitmap_r.Left + 6, bitmap_r.Top + 4 );
Canvas->LineTo( bitmap_r.Left + 13, bitmap_r.Top + 11 );

// top-right to bottom-left
// centre
Canvas->MoveTo( bitmap_r.Left + 12, bitmap_r.Top + 4 );
Canvas->LineTo( bitmap_r.Left + 4, bitmap_r.Top + 12 );

// left of centre
Canvas->MoveTo( bitmap_r.Left + 11, bitmap_r.Top + 4 );
Canvas->LineTo( bitmap_r.Left + 4, bitmap_r.Top + 11 );

// right of centre
Canvas->MoveTo( bitmap_r.Left + 12, bitmap_r.Top + 5 );
Canvas->LineTo( bitmap_r.Left + 5, bitmap_r.Top + 12 );
}
//---------------------------------------------------------------------------
void	__fastcall TDDForm::PaintFrame(HDC hdc,RECT frame_r)
{
// skip out if invalid DC
if (hdc == NULL) return;
if (DirectDraw == NULL) return;

//DirectDraw->Log(LOG_IN,"<<FORM>>::PaintFrame()","");

// set the canvas to paint on the supplied DC
Canvas->Handle = hdc;

// draw a 3d frame round the entire form
MyFrame3DWindow( Canvas, frame_r.left-1, frame_r.top-1, frame_r.right+1, frame_r.bottom+1, 4 );

// figure out the region in the caption area with the in/active caption color
TRect	caption_r;
caption_r.Left = frame_r.left + fBorderX;
caption_r.Top  = frame_r.top + fBorderY;
caption_r.Right = frame_r.right - fBorderX;
caption_r.Bottom = caption_r.Top + fCaptionHeight-1;

// fill in the caption area with the active caption color
if (fFormIsActive) Canvas->Brush->Color = clActiveCaption;
else Canvas->Brush->Color = clInactiveCaption;
Canvas->Brush->Style = bsSolid;
Canvas->FillRect( caption_r );

// draw line between caption bar and main draw area
Canvas->Pen->Color = clBtnFace;
Canvas->Pen->Width = fBorderY;
Canvas->MoveTo(caption_r.Left, caption_r.Bottom + 1);
Canvas->LineTo(caption_r.Right, caption_r.Bottom + 1);

// draw the "command" button (ie. user-defined icon on top,left corner)
int left = caption_r.Left + 2;
int top = caption_r.Top + 2;
if (BorderStyle != bsDialog) PaintCommandButton( hdc, left, top );

// draw the form's caption
if (fFormIsActive) Canvas->Brush->Color = clActiveCaption;
else Canvas->Brush->Color = clInactiveCaption;
Canvas->Font->Height = fCaptionHeight - 3;
Canvas->Font->Color = clYellow;//clCaptionText;
Canvas->Font->Style = Canvas->Font->Style << fsBold;
Canvas->Font->Name = fCaptionFontName;
TRect text_r;
text_r.Left = caption_r.Left+2;
if (BorderStyle != bsDialog) text_r.Left += fButtonWidth+2;
text_r.Right = caption_r.Right-4*fButtonWidth+fBorderX+2;
text_r.Top = caption_r.Top+1;
text_r.Bottom = caption_r.Bottom -2;
Canvas->TextRect( text_r, text_r.Left, text_r.Top, Caption );

// draw the "close window" button (ie. "X" on top,right corner)
left = caption_r.Right - fButtonWidth - 2;
PaintCloseButton( hdc, left , top );

// draw the "maximize window" button
if (BorderStyle != bsDialog)
	{
	left -= (fButtonWidth + 2);
	if (WindowState==wsMaximized) PaintRestoreButton( hdc, left, top );
	else PaintMaximizeButton( hdc, left, top );
    }

// draw the "minimize window" button
if (BorderStyle != bsDialog)
	{
	left -= fButtonWidth;
	if (WindowState==wsMinimized) PaintRestoreButton( hdc, left, top );
	else PaintMinimizeButton( hdc, left, top );
	}

// if the window is resizable
/* if (BorderStyle == bsSizeable)
	{
	// paint the horizontal scrollbar iff required
    if (HorzScrollBar->Visible)
		{
        // determine display coords for the scrollbar
        int left = frame_r.left + fBorderX + 1;
        int right = frame_r.right - fBorderX;
        int bottom = frame_r.bottom - fBorderY;
        int top  = bottom - fScrollbarHeight - 1;
        if (VertScrollBar->Visible) right -= fScrollbarWidth;
		// and paint the scrollbar
		PaintControlHScrollBar( hdc, left, top, right-left, bottom-top, HorzScrollBar->Position, HorzScrollBar->Range );
        }
	// paint the vertical scrollbar iff required
    if (VertScrollBar->Visible)
		{
        // determine display coords for the scrollbar
        int top    = frame_r.top + fCaptionHeight + fBorderY;
        int bottom = frame_r.bottom - fBorderY;
        int right = frame_r.right - fBorderX;
        int left =  right - fScrollbarWidth;
        if (HorzScrollBar->Visible) bottom -= fScrollbarHeight;
		// and paint the scrollbar
		PaintControlVScrollBar( hdc, left, top, right-left, bottom-top, VertScrollBar->Position, VertScrollBar->Range );
        }
    }
*/

// finished drawing, always release anything that may have been allocated by the Canvas
Canvas->Handle = NULL;

//DirectDraw->Log(LOG_OUT,"<<FORM>>::PaintFrame()","");
}
//---------------------------------------------------------------------------
void	__fastcall	TDDForm::PaintListBox( HDC hdc, TListBox* listbox )
{
// NOTE: when using the standard PaintTo() method to paint the control, most of the
// control gets painted to the supplied DC, but the scrollbars & cursor aren't painted.
// This has something to do with the way they (microsoft programmers) have optimized
// drawing once upon a time - there is only ONE display device ever, and only elements that
// have changed need to be repainted, never the whole scrollbar or whatever.
// MEANING: we have to manually paint the scrollbars, etc. Yuk, but that's life.

listbox->Canvas->Handle = hdc;
listbox->PaintTo(hdc,0,0);
listbox->Canvas->Handle = NULL;

// get information re: the vertical scrollbar
SCROLLINFO	scrollinfo;
scrollinfo.cbSize = sizeof(SCROLLINFO);
scrollinfo.fMask = SIF_ALL;
bool info_retrieved = (GetScrollInfo( listbox->Handle, SB_VERT, &scrollinfo ) != 0);
int rowsperpage = scrollinfo.nPage;
int maxrows = rowsperpage;
if (!listbox->IntegralHeight) maxrows++;

// if the info retrieved was valid and we need to display a scrollbar
if (info_retrieved && (listbox->Items->Count>maxrows))
	{
    Canvas->Handle = hdc;

	// vertical scroll bar
	int scrollbarpos = GetScrollPos( listbox->Handle, SB_VERT );
	int rowoffset = listbox->ItemIndex;
    int width = listbox->Width;
	int height = listbox->Height;
	int top = 2;
	int left = width - fScrollbarWidth - 2;
	int rowheight = listbox->ItemHeight;
    int totalrows = scrollinfo.nMax - scrollinfo.nMin + 1;

    // paint the vertical scrollbar
    PaintVScrollBar( Canvas->Handle, listbox->Handle, left, top, width, height, scrollbarpos, rowoffset, rowsperpage, totalrows );

	// now paint the windows "caret"
    // ie. draw the currently highlighted selections iff required
    if (listbox->ItemIndex != -1)
    	{
        // draw the rows of displayed text
        Canvas->Pen->Style = psClear;
		Canvas->Brush->Style = bsSolid;

        // scan through the number of visible rows
		for (int row=0;row<maxrows;row++)
        	{
            int tempindex = scrollbarpos + row;
            if (tempindex>listbox->Items->Count-1) break;

	        // draw the text for the highlight
	        TRect r;
	        r.Left = 2;
	        r.Right = left;
	        r.Top = row * rowheight + 2;
	        r.Bottom = r.Top + rowheight;
            if (r.Top>=listbox->Height-7) break;
            if (r.Bottom-r.Top>=listbox->Height-7) r.Bottom = r.Top + listbox->Height-7;
	        Canvas->Font->Name = listbox->Font->Name;
	        Canvas->Font->Style = listbox->Font->Style >> fsBold >> fsItalic >> fsUnderline;
	        Canvas->Font->Size = listbox->Font->Size;
			if (listbox->Selected[tempindex])
            	{
                Canvas->Font->Color = clWindow;
                Canvas->Brush->Color = clActiveCaption;
		        Canvas->TextRect( r, r.Left+2, r.Top, listbox->Items->Strings[tempindex] );
                }
            else
            	{
                Canvas->Font->Color = listbox->Font->Color;
                Canvas->Brush->Color = listbox->Color;
		        Canvas->TextRect( r, r.Left+2, r.Top, listbox->Items->Strings[tempindex] );
                }

            // draw the current row highlight as well
            if (listbox->Selected[tempindex] && (listbox->ItemIndex == tempindex) && (Screen->ActiveControl==listbox))
            	{
		        int i;
		        int even = listbox->ItemIndex % 2;
	            int rtop = r.Top;
	            int rleft = r.Left;
	            int rright = r.Right-1;
	            int rbottom = r.Bottom-1;

	            if (even)
                	{
			        for (i=rleft;i<rright;i+=2)
	                	{
		                Canvas->Pixels[i][rtop] = clWindow;
	                    Canvas->Pixels[i][rbottom] = clWindow;
	   	                }
                    for (i=rtop;i<rbottom;i+=2)
	                	{
		                Canvas->Pixels[rleft][i] = clWindow;
	                    Canvas->Pixels[rright][i] = clWindow;
                        }
                    Canvas->Pixels[rright][rbottom] = clWindow;
                    }
                else
	            	{
			        for (i=rleft+1;i<rright;i+=2)
	                	{
		                Canvas->Pixels[i][rtop] = clWindow;
	                    Canvas->Pixels[i][rbottom] = clWindow;
	   	                }
                    for (i=rtop+1;i<rbottom;i+=2)
	                	{
		                Canvas->Pixels[rleft][i] = clWindow;
	                    Canvas->Pixels[rright][i] = clWindow;
                    	}
                    }
                }
            }
        }
    Canvas->Handle = NULL;
    }
}
//---------------------------------------------------------------------------
void __fastcall	TDDForm::PaintVScrollBar( HDC hdc, HWND hwnd, int left, int top, int width, int height, int pos, int rowoffset, int rowsperpage, int totalrows )
{
Graphics::TBitmap* bitmap = new Graphics::TBitmap();
if (bitmap != NULL)
	{
    // figure some simple values
    int topofuparrow = top;
    int bottomofuparrow = top + fIconHeight;
    int topofdnarrow = height - fScrollbarHeight - 2;
	int bottomofdnarrow = height - 2;
    int topofthumbnailarea = bottomofuparrow-2;
    int bottomofthumbnailarea = topofdnarrow+1;

    // draw under the thumbnail
    Canvas->Pen->Style = psClear;
    Canvas->Pen->Color = clScrollBar;
    Canvas->Brush->Style = bsSolid;
	Canvas->Brush->Color = clScrollBar;
    Canvas->Rectangle( left, topofthumbnailarea, left + fIconWidth - 1, bottomofthumbnailarea );

    // draw up arrow
	bitmap->IgnorePalette = true;
	bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_UPARROW) );
	Canvas->Draw( left, topofuparrow, bitmap );
	bitmap->Handle = NULL;

	// draw down arrow
	bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_DNARROW) );
	Canvas->Draw( left, topofdnarrow, bitmap );
	bitmap->Handle = NULL;
	delete bitmap;

	// draw the thumbnail
    int pixelheight = bottomofthumbnailarea - topofthumbnailarea;
    int topofthumbnail = topofthumbnailarea;
    int thumbnailheight = 0;
    if (totalrows != 0)
    	{
        thumbnailheight += (int)(((float)pixelheight * (float)rowsperpage) / (float)totalrows);
        topofthumbnail += (int)(((float)pixelheight * (float)pos) / (float)totalrows);
	    if (pos+rowsperpage >= totalrows) topofthumbnail--;
        }
    if (thumbnailheight<8) thumbnailheight=8;

//    DirectDraw->Log(LOG_NOTE,"===============","scrollbarpos == " + IntToStr(pos));
//    DirectDraw->Log(LOG_NOTE,"===============","pixelheight == " + IntToStr(pixelheight));
//    DirectDraw->Log(LOG_NOTE,"===============","rowsperpage == " + IntToStr(rowsperpage));
//    DirectDraw->Log(LOG_NOTE,"===============","totalrows == " + IntToStr(totalrows));
//    DirectDraw->Log(LOG_NOTE,"===============","rowoffset == " + IntToStr(rowoffset));
//    DirectDraw->Log(LOG_NOTE,"===============","topofthumbnail == " + IntToStr(topofthumbnail));

    MyFrame3DThumbnail( Canvas, left, topofthumbnail, left + fIconWidth - 3, topofthumbnail + thumbnailheight - 1);
    }
}
//---------------------------------------------------------------------------
void __fastcall	TDDForm::PaintControlVScrollBar( HDC hdc, int left, int top, int width, int height, int pos, int range )

{
Graphics::TBitmap* bitmap = new Graphics::TBitmap();
if (bitmap != NULL)
	{
    // figure some simple values
    int leftofltarrow = left;
    int leftofrtarrow = left + width - fIconWidth;
    int leftofthumbnail = left + fIconWidth;

    // draw under the thumbnail
    Canvas->Pen->Style = psClear;
    Canvas->Pen->Color = clScrollBar;
    Canvas->Brush->Style = bsSolid;
	Canvas->Brush->Color = clScrollBar;
    Canvas->Rectangle( leftofthumbnail, top, leftofrtarrow-1, top + height-1 );

    // draw lt arrow
	bitmap->IgnorePalette = true;
	bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_LFARROW) );
	Canvas->Draw( leftofltarrow, top, bitmap );
	bitmap->Handle = NULL;

	// draw down arrow
	bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_RGARROW) );
	Canvas->Draw( leftofrtarrow, top, bitmap );
	bitmap->Handle = NULL;
	delete bitmap;

	// draw the thumbnail
    int pixelwidth = leftofrtarrow - leftofthumbnail;
    int thumbnailwidth = 0;
    if (range != 0)
    	{
        float fpos = (float) pos;
        float frange = (float) range;
        float fpixelwidth = (float) pixelwidth;

        thumbnailwidth = (int) (pixelwidth * (fpos / frange));
        leftofthumbnail += (int) (pixelwidth * (fpos / frange));
        }
    if (thumbnailwidth<8) thumbnailwidth=8;

    MyFrame3DThumbnail( Canvas, leftofthumbnail, top, leftofthumbnail + thumbnailwidth - 1, top + height );
    }
}
//---------------------------------------------------------------------------
void __fastcall	TDDForm::PaintControlHScrollBar( HDC hdc, int left, int top, int width, int height, int pos, int range )

{
Graphics::TBitmap* bitmap = new Graphics::TBitmap();
if (bitmap != NULL)
	{
    // figure some simple values
    int leftofltarrow = left;
    int leftofrtarrow = left + width - fIconWidth;
    int leftofthumbnail = left + fIconWidth;

    // draw under the thumbnail
    Canvas->Pen->Style = psClear;
    Canvas->Pen->Color = clScrollBar;
    Canvas->Brush->Style = bsSolid;
	Canvas->Brush->Color = clScrollBar;
    Canvas->Rectangle( leftofthumbnail, top, leftofrtarrow-1, top + height-1 );

    // draw lt arrow
	bitmap->IgnorePalette = true;
	bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_LFARROW) );
	Canvas->Draw( leftofltarrow, top, bitmap );
	bitmap->Handle = NULL;

	// draw down arrow
	bitmap->Handle = LoadBitmap( NULL, MAKEINTRESOURCE(OBM_RGARROW) );
	Canvas->Draw( leftofrtarrow, top, bitmap );
	bitmap->Handle = NULL;
	delete bitmap;

	// draw the thumbnail
    int pixelwidth = leftofrtarrow - leftofthumbnail;
    int thumbnailwidth = 0;
    if (range != 0)
    	{
        float fpos = (float) pos;
        float frange = (float) range;
        float fpixelwidth = (float) pixelwidth;

        thumbnailwidth = (int) (pixelwidth * (fpos / frange));
        leftofthumbnail += (int) (pixelwidth * (fpos / frange));
        }
    if (thumbnailwidth<8) thumbnailwidth=8;

    MyFrame3DThumbnail( Canvas, leftofthumbnail, top, leftofthumbnail + thumbnailwidth - 1, top + height );
    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::ExitButtonClick(TObject *Sender)
{
if (Enabled) Close();
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::ResetCountersClick(TObject *Sender)
{
fFramesFlipped = 0; fSeconds = 0; fAnimationTicks = 0;
Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::EnableDirectXButtonClick(TObject *Sender)
{
if (DirectDraw != NULL)
	{
    DirectDraw->Enabled = true;//!DirectDraw->Enabled;
    }
Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::UpdateDirectXMessages()
{
if (DirectDraw != NULL)
	{
    if (DirectDraw->Enabled)
		if (DirectDraw->ErrorStrings)
			{
			DebugMessages->Items->Clear();
			for (int i=0;i<DirectDraw->ErrorStrings->Count;i++)
				DebugMessages->Items->Add(DirectDraw->ErrorStrings->Strings[i]);
            DebugMessages->Repaint();
		    }
    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::FormDeactivate(TObject *Sender)
{
DebugMessages->Items->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::FormPaint(TObject *Sender)
{
// --------- normal FormPaint() drawing code using the VCL or GDI with Canvas->Handle as the DC

// display the number of frames, etc. being drawn
TDateTime current_time = Time();
unsigned short chour,cmin,csec,cmsec;
unsigned short lhour,lmin,lsec,lmsec;
current_time.DecodeTime(&chour,&cmin,&csec,&cmsec);
flast_time.DecodeTime(&lhour,&lmin,&lsec,&lmsec);
int seconds_elapsed = 0;
if (csec != lsec)
	{
    if (csec < lsec) seconds_elapsed += 60;
    seconds_elapsed += (csec - lsec);
    }
fSeconds += seconds_elapsed;
flast_time = current_time;

TicksLabel->Caption = "Ticks: " + IntToStr(fAnimationTicks);
FramesLabel->Caption = "Frames: " + IntToStr(fFramesFlipped);
SecondsLabel->Caption = "Seconds: " + IntToStr(fSeconds);
if (fSeconds != 0)
	{
    FramesPerSecondLabel->Caption = "FPS: " + FloatToStrF((float)fFramesFlipped / (float)fSeconds, ffFixed, 6, 2);
	}
AnimSpeedLabel->Caption = "Anim: " + IntToStr(AnimationTimer->Interval);

for (int z=0; z<1000; z++)
   	Canvas->Pixels[random(Width)][random(Height)] = (TColor) ((z << 16) + (z << 8) + z);

// also display some DirectX stats, etc.
if (DirectDraw != NULL)
	{
    DirectXInstalledLabel->Font->Color = clGreen;
    DirectXInstalledLabel->Caption = "DirectX is Installed";

	if (DirectDraw->Enabled)
		{
	    DirectXEnabledLabel->Font->Color = clGreen;
	    DirectXEnabledLabel->Caption = "DirectX drawing is enabled";
	    }
	else
		{
	    DirectXEnabledLabel->Font->Color = clRed;
	    DirectXEnabledLabel->Caption = "DirectX drawing is not enabled.";
	    }
	if (DirectDraw->Debugging)
		{
	    DirectXDebuggingLabel->Font->Color = clGreen;
	    DirectXDebuggingLabel->Caption = "DirectX debugging is enabled";
	    }
	else
		{
	    DirectXDebuggingLabel->Font->Color = clRed;
	    DirectXDebuggingLabel->Caption = "DirectX debugging is not enabled";
	    }
    }
else
	{
    DirectXInstalledLabel->Font->Color = clRed;
    DirectXInstalledLabel->Caption = "DirectX is Not Installed";
    }

// display a box moving about the screen (note: x,y,xincr,yincr global & just above function)
Canvas->Pen->Color = (TColor) RGB(255,255,255);
Canvas->Brush->Color = (TColor) RGB((fx*128)%256,(fx*16)%256,(fx*16+16*fColor)%256) ;
Canvas->Brush->Style = bsSolid;
Canvas->Rectangle( fx,fy, fx+400,fy+200 );

int xx = (fx*2>Width/2) ? fx*2 - Width/2 : Width/2 - fx*2;
int yy = (fy>Width/2) ? fy - Height/2: Height/2 - fy;
Image1->Visible = false;
Image1->SetBounds(xx,yy,fx/64+Image1->Width,fy/64+Image1->Height);
Image1->Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::RepaintMessagesButtonClick(TObject *Sender)
{
// make sure the scroll box of directx messages is realtime.....
UpdateDirectXMessages();
if (DebugMessages->Showing && (ActiveControl == DebugMessages))
	{
    DebugMessages->Hide();
    DebugMessages->Show();
    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::ClearMessagesButtonClick(TObject *Sender)
{
if (Enabled && (DirectDraw != NULL))
	{
    DirectDraw->ErrorStrings->Clear();
	Refresh();
    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::ToggleDebuggingButtonClick(TObject *Sender)
{
if (Enabled && (DirectDraw != NULL))
	{
    DirectDraw->Debugging = !DirectDraw->Debugging;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::AnimationTimerTimer(TObject *Sender)
{
fAnimationTicks++;
fColor++;
fx += fxincr;
fy += fyincr;

if (fx<0) fxincr = 1;
if (fy<0) fyincr = 1;
if (fx+400>Width) fxincr = -1;
if (fy+200>Height) fyincr = -1;

Image1->Left = fx;
//Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::BitBtn2Click(TObject *Sender)
{
if (AnimationTimer->Interval>1000) AnimationTimer->Interval -= 1000;
else if (AnimationTimer->Interval>100) AnimationTimer->Interval -= 100;
else if (AnimationTimer->Interval>10) AnimationTimer->Interval -= 10;
else if (AnimationTimer->Interval>1) AnimationTimer->Interval -= 1;
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::BitBtn4Click(TObject *Sender)
{
if (AnimationTimer->Interval<10) AnimationTimer->Interval += 1;
else if (AnimationTimer->Interval<100) AnimationTimer->Interval += 10;
else if (AnimationTimer->Interval<1000) AnimationTimer->Interval += 100;
else if (AnimationTimer->Interval<10000) AnimationTimer->Interval += 1000;
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::Button1Click(TObject *Sender)
{
Repaint();	
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::Button2Click(TObject *Sender)
{
AnimationTimer->Enabled = !AnimationTimer->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::ScrollBar1Scroll(TObject *Sender, TScrollCode ScrollCode, int &ScrollPos)
{
LittleAnimTimer->Interval = ScrollPos * 4;
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::LittleAnimTimerTimer(TObject *Sender)
{
int xx = 0;
int yy = 0;
int xxincr = 1;
int yyincr = 0;
if (DirectDraw != NULL)
	{
	xx += xxincr;
	yy += yyincr;

	if (xx<1) { yyincr = -1; xxincr = 0; xx = 1; }
	else if (xx > Screen->Width - Image2->Picture->Width) { yyincr = 1; xxincr = 0; xx = Screen->Width - Image2->Picture->Width; }
	if (yy<1) { xxincr = 1; yyincr = 0; yy = 1; }
	else if (yy > Screen->Height - Image2->Picture->Height - 1) { xxincr = -1; yyincr = 0; yy = Screen->Height - Image2->Picture->Height - 1; }

    // save whats currently on the backbuffer & underneath the new image
	TImage* under_image = DirectDraw->GetBackBufferImage(xx,yy,Image2->Picture->Width,Image2->Picture->Height);

    // copy what is currently displayed on the screen to the backbuffer
    DirectDraw->FlipGDIRectToBackBuffer(xx,yy,Image2->Picture->Width,Image2->Picture->Height);

    // copy the image over the top
    DirectDraw->BlitToBackBuffer(xx,yy,Image2,cmSrcCopy);	// CopyMode

    // display the updated screen area
    DirectDraw->FlipBackBufferRectToGDI(xx,yy,Image2->Picture->Width,Image2->Picture->Height);

    // restore what was underneath
    if (under_image != NULL)
    	{
        DirectDraw->BlitToBackBuffer(xx,yy,under_image);
	    delete under_image;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::FormCreate(TObject *Sender)
{
/* DirectDraw->Enabled = true;
if (DirectDraw != NULL)
	{
	if (DirectDraw->Enabled)
		{
		if (DirectDraw->SetDisplayMode(640,480,8))
	    	{
			DirectDraw->Log(LOG_NOTE,"",">>>>>>>>>>>>>> Display Mode Set to 640x480x8");
	        }
        }
    }
*/
fFramesFlipped = 0; fSeconds = 0; fAnimationTicks = 0;
}
//---------------------------------------------------------------------------
void __fastcall TDDForm::SpeedButton1Click(TObject *Sender)
{
//if (DirectDraw != NULL) DirectDraw->Log(LOG_NOTE,"INSERTION::",Edit1->Text);
}
//---------------------------------------------------------------------------
