//---------------------------------------------------------------------------
#ifndef TDirectDrawFormH
#define TDirectDrawFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
#include "TDirectDraw.h"
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------
class TDirectDrawTestForm : public TForm
{
__published:	// IDE-managed Components
	TPanel *TimingPanel;
	TLabel *FramesLabel;
	TLabel *SecondsLabel;
	TLabel *FramesPerSecondLabel;
	TTimer *SecondsTimer;
	TPanel *InformationPanel;
	TListBox *DirectDrawErrorMessagesBox;
	TBitBtn *ExitButton;
	TButton *PaintWithGDIButton;
	TButton *PaintWithVCLButton;
	TButton *PaintWithDirectDrawButton;
	TLabel *PaintWithLabel;
	TTimer *AnimationTimer;
	TLabel *DirectXInstalledLabel;
	TLabel *DrawingOnDirectXDCLabel;
	TShape *Shape1;
	TLabel *DebuggingLabel;
	TBitBtn *BitBtn1;
	TBitBtn *BitBtn2;
	TBitBtn *BitBtn3;
	TTimer *AutoFlipTimer;
	TLabel *TicksPerSecondLabel;
	TLabel *TicksLabel;
	TBitBtn *BitBtn4;
	TBitBtn *BitBtn5;
	TLabel *DrawingOnDirectXDCWorkedLabel;
	TLabel *SaveCanvasHandleLabel;
	TLabel *SaveCanvasHandleWorkedLabel;
	TLabel *RestoreCanvasHandleLabel;
	TLabel *RestoreCanvasHandleWorkedLabel;
	TLabel *DrawingVCLOnDirectXLabel;
	TLabel *DrawingVCLOnDirectXWorkedLabel;
	TLabel *SurfaceWasFlippedLabel;
	TLabel *ErrorLabel;
	TLabel *Label1;
	void __fastcall ExitButtonClick(TObject *Sender);
	void __fastcall PaintWithGDIButtonClick(TObject *Sender);
	void __fastcall PaintWithVCLButtonClick(TObject *Sender);
	void __fastcall PaintWithDirectDrawButtonClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall SecondsTimerTimer(TObject *Sender);
	void __fastcall AnimationTimerTimer(TObject *Sender);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall FormDeactivate(TObject *Sender);
	void __fastcall BitBtn1Click(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall BitBtn3Click(TObject *Sender);
	void __fastcall BitBtn2Click(TObject *Sender);
	void __fastcall AutoFlipTimerTimer(TObject *Sender);
	void __fastcall BitBtn4Click(TObject *Sender);
	void __fastcall BitBtn5Click(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	
	

private:	// User declarations
	TDirectDraw*		fDirectDraw;

	unsigned int		fAnimationTicks;
	unsigned int		fFramesFlipped;
    unsigned int		fSeconds;
    unsigned int		fColor;

    bool				fInsidePaintFunction;
    bool				fPaintWithVCL;
    bool				fPaintWithGDI;
    bool				fPaintWithDirectDrawDC;

    bool				fDrawingOnDirectXDC;
    bool				fDrawingOnDirectXDCWorked;
    bool				fSaveCanvasHandle;
    bool				fSaveCanvasHandleWorked;
    bool				fRestoreCanvasHandle;
    bool				fRestoreCanvasHandleWorked;
    bool				fDrawingVCLOnDirectX;
    bool				fDrawingVCLOnDirectXWorked;
    bool				fSurfaceWasFlipped;

protected:

//	void		__fastcall	PaintTo(HDC hdc, int X, int Y);		// not implemented yet
//	void		__fastcall	PaintWindow(HDC hdc);				// no need to implement;
																// TForm->PaintWindow is very simple
//	void 		__fastcall ClientWndProc(Messages::TMessage &Message);
//virtual void 	__fastcall	WndProc(Messages::TMessage &Message);
	void		__fastcall	PaintWindow(HDC hdc);
	void		__fastcall	PaintControls(HDC hdc, TControl* First);
//void 			__fastcall	PaintHandler(Messages::TWMPaint &Message);
//BEGIN_MESSAGE_MAP
//  MESSAGE_HANDLER(WM_PAINT, TWMPaint, PaintHandler)
//END_MESSAGE_MAP

	void		__fastcall	PaintWithVCL();
	void		__fastcall	PaintWithGDI();

public:		// User declarations
				__fastcall 	TDirectDrawTestForm(TComponent* Owner);
	virtual		__fastcall 	~TDirectDrawTestForm();
    void		__fastcall	UpdateDirectXMessages();
//	HDC			__fastcall	GetDeviceContext(HWND &WindowHandle);

	__property	TDirectDraw*	DirectDraw = {read=fDirectDraw};
};
//---------------------------------------------------------------------------
extern TDirectDrawTestForm *DirectDrawTestForm;
//---------------------------------------------------------------------------
#endif
/*

procedure TForm. ClientWndProc(var Message: TMessage);

  procedure Default;
  begin
    with Message do
      Result := CallWindowProc(FDefClientProc, ClientHandle, Msg, wParam, lParam);
  end;

begin
  with Message do
    case Msg of
      WM_NCHITTEST:
        begin
          Default;
          if Result = HTCLIENT then Result := HTTRANSPARENT;
        end;
      WM_ERASEBKGND:
        begin
          FillRect(TWMEraseBkGnd(Message).DC, ClientRect, Brush.Handle);
          Result := 1;
        end;
    else
      Default;
    end;
end;

*/

