//---------------------------------------------------------------------------
#ifndef TDirectDrawFormH
#define TDirectDrawFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
#include "TDirectDraw.h"
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------
class TDirectDrawForm : public TForm
{
__published:	// IDE-managed Components
	TPanel *TimingPanel;
	TLabel *FramesLabel;
	TLabel *SecondsLabel;
	TLabel *FramesPerSecondLabel;
	TTimer *SecondsTimer;
	TPanel *InformationPanel;
	TListBox *DirectDrawErrorMessagesBox;
	TBitBtn *ExitButton;
	TButton *PaintWithGDIButton;
	TButton *PaintWithVCLButton;
	TButton *PaintWithDirectDrawButton;
	TLabel *PaintWithLabel;
	TTimer *AnimationTimer;
	TLabel *DirectXInstalledLabel;
	TLabel *DrawingOnDirectXDCLabel;
	TShape *Shape1;
	TLabel *DebuggingLabel;
	TBitBtn *BitBtn1;
	TBitBtn *BitBtn2;
	TBitBtn *BitBtn3;
	TTimer *AutoFlipTimer;
	TLabel *TicksPerSecondLabel;
	TLabel *TicksLabel;
	TBitBtn *BitBtn4;
	TBitBtn *BitBtn5;
	TLabel *DrawingOnDirectXDCWorkedLabel;
	TLabel *SaveCanvasHandleLabel;
	TLabel *SaveCanvasHandleWorkedLabel;
	TLabel *RestoreCanvasHandleLabel;
	TLabel *RestoreCanvasHandleWorkedLabel;
	TLabel *DrawingVCLOnDirectXLabel;
	TLabel *DrawingVCLOnDirectXWorkedLabel;
	TLabel *SurfaceWasFlippedLabel;
	TLabel *ErrorLabel;
	TSpeedButton *SpeedButton1;
	TSpeedButton *SpeedButton2;
	TEdit *Edit1;
	TEdit *Edit2;
	TEdit *Edit3;
	void __fastcall ExitButtonClick(TObject *Sender);
	void __fastcall PaintWithGDIButtonClick(TObject *Sender);
	void __fastcall PaintWithVCLButtonClick(TObject *Sender);
	void __fastcall PaintWithDirectDrawButtonClick(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall SecondsTimerTimer(TObject *Sender);
	void __fastcall AnimationTimerTimer(TObject *Sender);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall FormDeactivate(TObject *Sender);
	void __fastcall BitBtn1Click(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall BitBtn3Click(TObject *Sender);
	void __fastcall BitBtn2Click(TObject *Sender);
	void __fastcall AutoFlipTimerTimer(TObject *Sender);
	void __fastcall BitBtn4Click(TObject *Sender);
	void __fastcall BitBtn5Click(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	
	

	void __fastcall SpeedButton1Click(TObject *Sender);
	void __fastcall SpeedButton2Click(TObject *Sender);
	
private:	// User declarations
	TDirectDraw*		fDirectDraw;

	unsigned int		fAnimationTicks;
	unsigned int		fFramesFlipped;
    unsigned int		fSeconds;
    unsigned int		fColor;

    signed int			fControlBeingPainted;
    
    HDC					fWndProcDC;
    bool				fHandlingWMPAINT;
    bool				fHandlingWMDRAWITEM;

    bool				fPaintWithVCL;
    bool				fPaintWithGDI;
    bool				fPaintWithDirectDrawDC;

    bool				fDrawingOnDirectXDC;
    bool				fDrawingOnDirectXDCWorked;
    bool				fSaveCanvasHandle;
    bool				fSaveCanvasHandleWorked;
    bool				fRestoreCanvasHandle;
    bool				fRestoreCanvasHandleWorked;
    bool				fDrawingVCLOnDirectX;
    bool				fDrawingVCLOnDirectXWorked;
    bool				fSurfaceWasFlipped;

protected:

// BEGIN overloaded VCL functions used to draw the form / controls
virtual void 		__fastcall	WndProc(Messages::TMessage &Message);     	// Forms.Pas & Controls.Pas
		void		__fastcall	PaintWindow(HDC hdc);						// Forms.Pas & Controls.Pas
		void		__fastcall	PaintControls(HDC hdc, TControl* First);	// Controls.Pas
		void 		__fastcall	PaintHandler(Messages::TWMPaint &Message);	// Controls.Pas
		void		__fastcall	Repaint();
// END overloaded VCL functions used to draw the form / controls

// BEGIN extra functions used to draw the form / controls
// Func: PaintForm()
// ????: VCL uses a Win32 function Ctl3dDlgFramePaint() which seems to paint
// 		 the form before automatically blitting the changes, which is what we don't want...
//		 Since this doesn't conform, no other way but to draw the form ourselves -> yuk.
//		 then again, gives us a way of programming in a shareware / registered difference.
//		 ie. shareware _always_ has a fixed "TDirectXForm, SHAREWARE release v1.0 (c) 1997 Darren J. Dwyer - All Rights Reserved"
		void		__fastcall	PaintForm(HDC hdc);
// END extra functions used to draw the form / controls

	void		__fastcall	PaintWithVCL();
	void		__fastcall	PaintWithGDI();

public:		// User declarations
				__fastcall 	TDirectDrawForm(TComponent* Owner);
	virtual		__fastcall 	~TDirectDrawForm();
    void		__fastcall	UpdateDirectXMessages();

	__property	TDirectDraw*	DirectDraw = {read=fDirectDraw};
};
//---------------------------------------------------------------------------
extern TDirectDrawForm *DirectDrawForm;
//---------------------------------------------------------------------------
#endif


